﻿using PropertyChanged;
using System;
using System.Data;

namespace DataDisplayBoard.Model
{
    [AddINotifyPropertyChangedInterface]
    public class CarrierModel
    {
        public int CarrierID { get; set; }

        public string TaskNo { get; set; }

        public int PocketNumber { get; set; }

        public int PullNumber { get; set; }

        public string Barcode1 { get; set; }

        public string Barcode2 { get; set; }

        public string Barcode3 { get; set; }

        public int FirstRollLayer { get; set; }

        public string FirstPileNo { get; set; }

        public int FirstTopLayerNumber { get; set; }

        public string FirstRollMaterialType { get; set; }

        public string FirstRollMaterialQuantity { get; set; }

        public string FirstRollBFinished { get; set; }

        public int SecondRollLayer { get; set; }

        public string SecondPileNo { get; set; }

        public int SecondTopLayerNumber { get; set; }

        public string SecondRollMaterialType { get; set; }

        public string SecondRollMaterialQuantity { get; set; }

        public string SecondRollBFinished { get; set; }

        public bool IsSelected { get; set; }

        public CarrierModel()
        {

        }

        public CarrierModel(DataRow dataRow)
        {
            CarrierID = Convert.ToInt32(dataRow["CarID"]); TaskNo = dataRow["TaskNo"]?.ToString();
            PocketNumber = Convert.ToInt32(dataRow["PocketNumber"]); PullNumber = Convert.ToInt32(dataRow["PullNumber"]);
            Barcode1 = dataRow["Barcode1"]?.ToString(); Barcode2 = dataRow["Barcode2"]?.ToString(); Barcode3 = dataRow["Barcode3"]?.ToString();

            FirstRollLayer = Convert.ToInt32(dataRow["FirstRollLayer"]); FirstPileNo = dataRow["FirstPileNo"]?.ToString();
            FirstTopLayerNumber = Convert.ToInt32(dataRow["FirstTopLayerNumber"]);
            FirstRollMaterialQuantity = dataRow["FirstRollMaterialQuantity"]?.ToString() == "3" ? "不合格" : "合格";
            switch (dataRow["FirstRollMaterialType"]?.ToString())
            {
                case "1": FirstRollMaterialType = "单相电表"; break;
                case "2": FirstRollMaterialType = "三相电表"; break;
                case "3": FirstRollMaterialType = "互感式电表"; break;
                case "4": FirstRollMaterialType = "混用电表"; break;
                default: FirstRollMaterialType = "无"; break;
            }
            FirstRollBFinished = dataRow["FirstRollBFinished"]?.ToString() == "1" ? "完成" : "未完成";

            SecondRollLayer = Convert.ToInt32(dataRow["SecondRollLayer"]); SecondPileNo = dataRow["SecondPileNo"]?.ToString();
            SecondTopLayerNumber = Convert.ToInt32(dataRow["SecondTopLayerNumber"]);
            SecondRollMaterialQuantity = dataRow["SecondRollMaterialQuantity"]?.ToString() == "3" ? "不合格" : "合格";
            switch (dataRow["SecondRollMaterialType"]?.ToString())
            {
                case "1": SecondRollMaterialType = "单相电表"; break;
                case "2": SecondRollMaterialType = "三相电表"; break;
                case "3": SecondRollMaterialType = "互感式电表"; break;
                case "4": SecondRollMaterialType = "混用电表"; break;
                default: SecondRollMaterialType = "无"; break;
            }
            SecondRollBFinished = dataRow["SecondRollBFinished"]?.ToString() == "1" ? "完成" : "未完成";
        }
    }
}
