﻿using PropertyChanged;
using System;
using System.Collections.Generic;
using System.Data;

namespace DataDisplayBoard.Model 
{
    [AddINotifyPropertyChangedInterface]
    public class ElectricMeterModel
    {
        public string EpitopeNumber { get; set; }

        public string TaskNo { get; set; }

        public int RowIndex { get; set; }

        public int ColumnIndex { get; set; }

        public bool Status { get; set; }

        public string Barcode { get; set; }

        public int Quantity { get; set; }

        public ElectricMeterModel(DataRow dataRow)
        {
            EpitopeNumber = dataRow["EpitopeNumber"]?.ToString(); TaskNo = dataRow["TaskNo"]?.ToString();
            RowIndex = Convert.ToInt32(dataRow["RowIndex"]); ColumnIndex = Convert.ToInt32(dataRow["ColumnIndex"]);
            Status = Convert.ToInt32(dataRow["Status"]) == 1; Quantity = Convert.ToInt32(dataRow["Quantity"]);
            Barcode = dataRow["Barcode"]?.ToString();
        }

        public static List<ElectricMeterModel> ToList(DataTable dataTable)
        {
            if (dataTable == null || dataTable.Rows.Count == 0) { return null; }
            List<ElectricMeterModel> ElectircMeterList = new List<ElectricMeterModel>();
            foreach (DataRow item in dataTable.Rows)
            {
                ElectircMeterList.Add(new ElectricMeterModel(item));
            }
            return ElectircMeterList;
        }
    }
}
