﻿using System;
using System.Data;
using System.Windows.Controls;

namespace DataDisplayBoard.Model
{
    public class MesTaskModel
    {
        public int TaskID { get; set; } 

        public string TaskNo { get; set; }

        public string PileNo { get; set; }

        public string StationNo { get; set; } = "1";

        public string TaskStatus { get; set; } = "";

        public string MaterialType { get; set; } = "";

        public string TaskType { get; set; } = "";

        public string StartStation { get; set; } = "";

        public string EndStation { get; set; } = "";

        public string CallTime { get; set; }

        public bool IsSelected { get; set; }

        public Button Button { get; set; }

        public MesTaskModel()
        {

        }

        public MesTaskModel(DataRow dataRow)
        {
            if (dataRow.Table.Columns.Contains("ID"))
            {
                TaskID = Convert.ToInt32(dataRow["ID"]);
            }
            if (dataRow.Table.Columns.Contains("PileNo"))
            {
                PileNo = dataRow["PileNo"]?.ToString();
            }
            if (dataRow.Table.Columns.Contains("TaskNo"))
            {
                TaskNo = dataRow["TaskNo"]?.ToString();
            }
            if (dataRow.Table.Columns.Contains("StationNo"))
            {
                StationNo = dataRow["StationNo"]?.ToString();
            }
            if (dataRow.Table.Columns.Contains("StartStation"))
            {
                StartStation = dataRow["StartStation"]?.ToString();
            }
            if (dataRow.Table.Columns.Contains("EndStation"))
            {
                EndStation = dataRow["EndStation"]?.ToString();
            }
            if (dataRow.Table.Columns.Contains("MaterialType"))
            {
                switch (dataRow["MaterialType"]?.ToString())
                {
                    case "1": MaterialType = "单相电表"; break;
                    case "2": MaterialType = "三相互感"; break;
                    case "3": MaterialType = "三相直接"; break;
                    case "4": MaterialType = "终端小电流"; break;
                    case "5": MaterialType = "终端大电流"; break;
                    case "6": MaterialType = "互感器"; break;
                    default: MaterialType = "未知"; break;
                }
            }
            if (dataRow.Table.Columns.Contains("TaskStatus"))
            {
                switch (dataRow["TaskStatus"]?.ToString())
                {
                    case "1": TaskStatus = "任务下发"; break;
                    case "2": TaskStatus = "任务生成"; break;
                    case "3": TaskStatus = "任务异常"; break;
                    case "4": TaskStatus = "任务单点完成"; break;
                    case "10": TaskStatus = "任务完成"; break;
                    case "11": TaskStatus = "挂表上报完成"; break;
                    case "20": TaskStatus = "工单完成"; break;
                    case "21": TaskStatus = "工单上报完成"; break;
                    default: TaskStatus = dataRow["TaskStatus"]?.ToString(); break;
                }
            }
            if (dataRow.Table.Columns.Contains("TaskType"))
            {
                switch (dataRow["TaskType"]?.ToString())
                {
                    case "1": TaskType = "全部合格"; break;
                    case "2": TaskType = "部分合格"; break;
                    case "3": TaskType = "不合格"; break;
                    default: TaskType = "未知"; break;
                }
            }
            if (dataRow.Table.Columns.Contains("CallTime"))
            {
                CallTime = dataRow["CallTime"]?.ToString();
            }

            Button = new Button();
            Button.Content = "保存";
            Button.Click += Button_Click;
        }

        private void Button_Click(object sender, System.Windows.RoutedEventArgs e)
        {
            
        }
    }
}
