﻿using DataDisplayBoard.ViewModel;
using PropertyChanged;
using System;
using System.Data;

namespace DataDisplayBoard.Model
{
    [AddINotifyPropertyChangedInterface]
    public class LocationModel : BaseViewModel
    {
        public string LocationCode { get; set; }

        public string WareHouseCode { get; set; }

        public string TaskNo { get; set; }

        public string PileNo { get; set; }

        public string MaterialType { get; set; }

        public string Quantity { get; set; }

        public string RollLayer { get; set; }

        public string TopLayerNumber { get; set; }

        public string BFinish { get; set; }

        public int RowIndex { get; set; } = 1;

        public int ColumnIndex { get; set; }

        public int Status { get; set; }

        public LocationModel()
        {

        }

        public LocationModel(DataRow dataRow)
        {
            WareHouseCode = dataRow["WareHouseCode"]?.ToString(); LocationCode = dataRow["LocationCode"]?.ToString(); Status = Convert.ToInt32(dataRow["Status"]);

            if (WareHouseCode == "WH001")
            {
                if (Convert.ToInt32(LocationCode.Split('_')[1]) < 28)
                {
                    ColumnIndex = Convert.ToInt32(LocationCode.Split('_')[1]) - 18;
                }
                else
                {
                    RowIndex = 2; ColumnIndex = Convert.ToInt32(LocationCode.Split('_')[1]) - 27;
                }
            }
            else if (WareHouseCode == "WH002")
            {
                ColumnIndex = Convert.ToInt32(LocationCode.Split('_')[1]) - 11;
            }
            else if (WareHouseCode == "WH003")
            {
                ColumnIndex = Convert.ToInt32(LocationCode.Split('_')[1]);
            }
            else if (WareHouseCode == "WH004")
            {
                ColumnIndex = Convert.ToInt32(LocationCode.Split('_')[1]) - 5;
            }
            else if (WareHouseCode == "WH005")
            {
                ColumnIndex = Convert.ToInt32(LocationCode.Split('_')[1]) - 99;
            }

            TaskNo = dataRow["Attribute1"]?.ToString(); PileNo = dataRow["Attribute2"]?.ToString();
            MaterialType = dataRow["Attribute3"]?.ToString(); Quantity = dataRow["Attribute4"]?.ToString();
            RollLayer = dataRow["Attribute5"]?.ToString(); TopLayerNumber = dataRow["Attribute6"]?.ToString();
            BFinish = dataRow["Attribute7"]?.ToString();
        }

        public void SetStatus(int Status)
        {
            this.Status = Status; OnPropertyChanged(nameof(Status));
        }
    }
}
