﻿using DataDisplayBoard.Model;
using MaxCommunication.DataBase.SQLServer;
using Microsoft.Practices.Prism.Commands;
using PropertyChanged;
using System;
using System.Collections.ObjectModel;
using System.Data;
using System.Windows;

namespace DataDisplayBoard.ViewModel
{
    //AGV两个滚筒载货情况编辑
    [AddINotifyPropertyChangedInterface]
    public class CarrierViewModel
    {
        public SQLServerExtension sqlServerExtension { get; set; } = new SQLServerExtension("server=.;uid=sa;pwd=123;database=PMS_KLDZ_6324");

        public ObservableCollection<CarrierModel> CarrierCollection { get; set; } = new ObservableCollection<CarrierModel>();

        public CarrierModel CarrierModel { get; set; }

        public DelegateCommand ReflushCommand => new DelegateCommand(ReflushCarrier);

        public DelegateCommand<string> DeleteCommand => new DelegateCommand<string>(DeleteCarrier);

        public CarrierViewModel()
        {
            ReflushCarrier();
        }

        public void ReflushCarrier()
        {
            DataTable dataTable = sqlServerExtension.QueryTable("PMS_Max_Carrier");
            if (dataTable == null || dataTable.Rows.Count == 0) { CarrierCollection.Clear(); return; }
            sqlServerExtension.Disconnect(); CarrierCollection.Clear();
            foreach (DataRow item in dataTable.Rows)
            {
                CarrierCollection.Add(new CarrierModel(item));
            }
        }

        public void DeleteCarrier(string RollSite)
        {
            if (CarrierCollection == null || CarrierCollection.Count == 0) { return; }
            string carriers = "";
            string TaskIDArr = "";
            foreach (CarrierModel item in CarrierCollection)
            {
                if (!item.IsSelected) { continue; }
                if (TaskIDArr.Length == 0)
                {
                    TaskIDArr = $"{item.CarrierID}";
                }
                else
                {
                    TaskIDArr = TaskIDArr + $",{item.CarrierID}";
                }
                carriers = carriers+"AGV" + item.CarrierID + " ";
            }
            MessageBoxResult messageBoxResult = MessageBox.Show("确实要删除" + carriers + "的滚筒和抓表数据吗？", "询问",MessageBoxButton.YesNoCancel);
            if (messageBoxResult == MessageBoxResult.Yes)
            {
               
                sqlServerExtension.DeleteRecord("PMS_Max_Carrier", $"where CarID in ({TaskIDArr})");
                //foreach (CarrierModel item in CarrierCollection)
                {
                    //if (!item.IsSelected) { continue; }
                    //if (RollSite == "First")
                    //{
                    //    sqlServerExtension.UpdateRecord("PMS_Max_Carrier", "FirstRollLayer = 0,FirstPileNo = 0,FirstTopLayerNumber = 0," +
                    //        "FirstRollMaterialType = 0,FirstRollMaterialQuantity = 0,FirstRollBFinished = 0", $"where CarID = {item.CarrierID}");
                    //}
                    //else if (RollSite == "Second")
                    //{
                    //    sqlServerExtension.UpdateRecord("PMS_Max_Carrier", "SecondRollLayer = 0,SecondPileNo = 0,SecondTopLayerNumber = 0," +
                    //        "SecondRollMaterialType = 0,SecondRollMaterialQuantity = 0,SecondRollBFinished = 0", $"where CarID = {item.CarrierID}");
                    //}
                    //else if (RollSite == "All")
                    //{
                    //    sqlServerExtension.DeleteRecord("PMS_Max_Carrier", $"where CarID = {item.CarrierID}");
                    //}
                    //else
                    //{
                    //    sqlServerExtension.DeleteRecord("PMS_Max_Carrier", $"where CarID = {item.CarrierID}");
                    //}
                    ReflushCarrier(); sqlServerExtension.Disconnect();
                }
            }
        }
    }
}
