﻿using DataDisplayBoard.Model;
using MaxCommunication.DataBase.SQLServer;
using Microsoft.Practices.Prism.Commands;
using PropertyChanged;
using System.Collections.ObjectModel;
using System.Data;
using System.Linq;

namespace DataDisplayBoard.ViewModel
{
    //表质量编辑
    [AddINotifyPropertyChangedInterface]
    public class ElectricMeterEquipmentViewModel : BaseViewModel
    {
        public SQLServerExtension sqlServerExtension { get; set; } = new SQLServerExtension("server=.;uid=sa;pwd=123;database=PMS_KLDZ_6324");

        public ObservableCollection<ElectricMeterViewModel> ElectricCollection { get; set; } = new ObservableCollection<ElectricMeterViewModel>();

        public string DeceiveName { get; set; } = "";

        public string DeceiveNo { get; set; } = "";

        public int BadNumber { get; set; }

        public DelegateCommand SearchCommand => new DelegateCommand(SearchDeceive);

        public DelegateCommand ReflushCommand => new DelegateCommand(SearchDeceive);

       

        public ElectricMeterEquipmentViewModel()
        {
        }

        public void SearchDeceive()
        {
            if (DeceiveNo == null && DeceiveNo.Length == 0) { return; }
            DataTable dataTable = sqlServerExtension.QueryTable("PMS_Max_DeceiveManager", $"where DeceiveName = '{DeceiveNo}'");
            if (dataTable == null || dataTable.Rows.Count == 0) { return; }
            dataTable = sqlServerExtension.QueryTable("PMS_Max_" + dataTable.Rows[0]["WorkStationName"]?.ToString());
            if (dataTable == null || dataTable.Rows.Count == 0) { return; }
            ElectricCollection.Clear(); DeceiveName = $"电 表 设 备：{DeceiveNo} 信 息 显 示"; OnPropertyChanged(nameof(DeceiveName));
            foreach (DataRow item in dataTable.Rows)
            {
                ElectricCollection.Add(new ElectricMeterViewModel(new ElectricMeterModel(item)));
            }
            BadNumber = (int)ElectricCollection.Where(t => t.ElectricMeterModel.Status && t.ElectricMeterModel.Quantity == 2).ToList()?.Count();
            OnPropertyChanged(nameof(BadNumber));
        }

        public void ExcerptWatchTask()
        {
            SQLServerExtension sqlServerExtention = new SQLServerExtension("server =.; uid=sa;pwd=123;database=PMS_KLDZ_6324");
            if (DeceiveNo == null && DeceiveNo.Length == 0) { return; }
            DataTable dataTable = sqlServerExtension.QueryTable("PMS_Max_DeceiveManager", $"where DeceiveName = '{DeceiveNo}'");
            if (dataTable == null || dataTable.Rows.Count == 0) { return; }
            dataTable = sqlServerExtension.QueryTable("PMS_Max_" + dataTable.Rows[0]["WorkStationName"]?.ToString(), $"where Status = 1 and Quantity<>0");//PMS_Max_MesEWTask
            if (dataTable == null || dataTable.Rows.Count == 0) { return; }

            //string values = $"0,'{TrayBarcodeModel.TrayBarcode}','{TrayBarcodeModel.Barcode1}','{TrayBarcodeModel.Barcode2}','{TrayBarcodeModel.Barcode3}'," +
            //             $"'{TrayBarcodeModel.Barcode4}','{TrayBarcodeModel.Barcode5}','{TrayBarcodeModel.Barcode6}','{TrayBarcodeModel.Barcode7}','{TrayBarcodeModel.Barcode8}'," +
            //             $"'{TrayBarcodeModel.Barcode9}','{TrayBarcodeModel.Barcode10}','{TrayBarcodeModel.Barcode11}','{TrayBarcodeModel.Barcode12}'";
            //sqlServerExtention.AddRecord("PMS_Max_MesEWTask", values);
        }
    }
}
