﻿using System;
using System.Collections.ObjectModel;
using System.Windows.Threading;

namespace DataDisplayBoard.ViewModel
{
    public class ObservableCollectionMarshaler
    {
        public Dispatcher dispatcher { get; set; }

        public ObservableCollectionMarshaler()
        {
            dispatcher = Dispatcher.CurrentDispatcher;
        }

        public void AddItem<T>(ObservableCollection<T> collection, T item)
        {
            if (dispatcher.CheckAccess())
            {
                collection.Add(item);
            }
            else
            {
                dispatcher.Invoke(new Action<T>(t => collection.Add(t)), DispatcherPriority.Normal, item);
            }
        }

        public void Clear<T>(ObservableCollection<T> collection)
        {
            if (dispatcher.CheckAccess())
            {
                collection.Clear();
            }
            else
            {
                dispatcher.Invoke(new Action(() => collection.Clear()), DispatcherPriority.DataBind);
            }
        }
    }
}
