﻿using DataDisplayBoard.Model;
using MaxCommunication.DataBase.SQLServer;
using Microsoft.Practices.Prism.Commands;
using PropertyChanged;

namespace DataDisplayBoard.ViewModel
{
    [AddINotifyPropertyChangedInterface]
    public class DetailLocationViewModel
    {
        public SQLServerExtension sqlServerExtension { get; set; } = new SQLServerExtension("server=.;uid=sa;pwd=123;database=WMS_KLDZ_6324");

        public LocationModel LocationModel { get; set; }

        public string[] StatusArr { get; set; } = new string[] { "满", "空", "锁定" };

        public string[] MaterialTypeArr { get; set; } = new string[] { "单相电表", "三相电表", "互感式电表", "混用电表" };

        public string[] MaterialQuantityArr { get; set; } = new string[] { "全部合格", "部分合格", "不合格" };

        public string[] MaterialFinishArr { get; set; } = new string[] { "完成", "未完成" };

        public DelegateCommand SaveCommand => new DelegateCommand(SaveRecorde);

        public DetailLocationViewModel()
        {

        }

        public DetailLocationViewModel(LocationModel LocationModel)
        {
            this.LocationModel = LocationModel;
        }

        public void SaveRecorde()
        {
            sqlServerExtension.UpdateRecord("t_wh_locationProperty", $"Status = {LocationModel.Status},Attribute1 = '{LocationModel.TaskNo}'," +
                $"Attribute2 = '{LocationModel.PileNo}',Attribute3 = '{LocationModel.MaterialType}',Attribute4 = '{LocationModel.Quantity}'," +
                $"Attribute5 = {LocationModel.RollLayer},Attribute6 = {LocationModel.TopLayerNumber},Attribute7 = '{LocationModel.BFinish}'", $"where LocationCode = '{LocationModel.LocationCode}'");
            sqlServerExtension.Disconnect();
        }
    }
}
