﻿using DataDisplayBoard.Model;
using MaxCommunication.DataBase.SQLServer;
using Microsoft.Practices.Prism.Commands;
using PropertyChanged;

namespace DataDisplayBoard.ViewModel
{
    [AddINotifyPropertyChangedInterface]
    public class LocationViewModel
    {
        public SQLServerExtension sqlServerExtension = new SQLServerExtension("server=.;uid=sa;pwd=123;database=WMS_KLDZ_6324");

        public LocationModel LocationModel { get; set; }

        public DelegateCommand SetFullCommand { get; set; }

        public DelegateCommand SetEmptyCommand { get; set; }

        public LocationViewModel()
        {
        }

        public LocationViewModel(LocationModel LocationModel)
        {
            this.LocationModel = LocationModel;
            SetFullCommand = new DelegateCommand(SetFullWareHouse);
            SetEmptyCommand = new DelegateCommand(SetEmptyWareHouse);
        }

        public void SetFullWareHouse()
        {
            sqlServerExtension.UpdateRecord("t_wh_locationProperty", "status = 1", $"where LocationCode = '{LocationModel.LocationCode}'");
            sqlServerExtension.Disconnect();
        }

        public void SetEmptyWareHouse()
        {
            sqlServerExtension.UpdateRecord("t_wh_locationProperty", "status = 2", $"where LocationCode = '{LocationModel.LocationCode}'");
            sqlServerExtension.Disconnect();
        }
    }
}
