﻿using DataDisplayBoard.Model;
using MaxCommunication.DataBase.SQLServer;
using PropertyChanged;
using System.Collections.ObjectModel;
using System.Data;
using System.Linq;
using System.Threading;
using System.Threading.Tasks;

namespace DataDisplayBoard.ViewModel
{
    [AddINotifyPropertyChangedInterface]
    public class WareHouseAreaViewModel : BaseViewModel
    {
        public SQLServerExtension sqlServerExtension = new SQLServerExtension("server=.;uid=sa;pwd=123;database=WMS_KLDZ_6324");

        public ObservableCollection<LocationViewModel> LocationCollection { get; set; } = new ObservableCollection<LocationViewModel>();

        public ObservableCollectionMarshaler observableCollectionMarshaler { get; set; } = new ObservableCollectionMarshaler();

        public string WareHouseCode { get; set; }

        public string WareHouseName { get; set; }

        public WareHouseAreaViewModel()
        {

        }

        public WareHouseAreaViewModel(string WareHouseCode, string WareHouseName)
        {
            this.WareHouseCode = WareHouseCode; this.WareHouseName = WareHouseName;
            Task.Factory.StartNew(ReflushWareHouse);
        }

        public void ReflushWareHouse()
        {
            while (true)
            {
                Thread.Sleep(1000);
                DataTable dataTable = sqlServerExtension.QueryTable("t_wh_locationProperty", $"where WareHouseCode = '{WareHouseCode}'");
                if (dataTable == null || dataTable.Rows.Count == 0) { return; }
                foreach (DataRow item in dataTable.Rows)
                {
                    LocationViewModel locationViewModel = LocationCollection.FirstOrDefault(t => t.LocationModel.LocationCode == item["LocationCode"]?.ToString());
                    if (locationViewModel != null)
                    {
                        //locationViewModel.LocationModel.SetStatus(System.Convert.ToInt32(item["Status"])); 
                    }
                    else
                    {
                        //LocationCollection.Add(new LocationViewModel(new LocationModel(item)));
                        observableCollectionMarshaler.AddItem(LocationCollection, new LocationViewModel(new LocationModel(item)));
                    }
                }
                
            }
        }
    }
}
