﻿using MaxCommunication.DataBase.SQLServer;
using PropertyChanged;
using System.Collections.ObjectModel;
using System.Data;

namespace DataDisplayBoard.ViewModel
{
    [AddINotifyPropertyChangedInterface]
    public class WareHouseViewModel
    {
        public SQLServerExtension sqlServerExtension = new SQLServerExtension("server=.;uid=sa;pwd=123;database=WMS_KLDZ_6324");

        public ObservableCollection<WareHouseAreaViewModel> WareHouseAreaCollection { get; set; } = new ObservableCollection<WareHouseAreaViewModel>();
         
        public ObservableCollectionMarshaler observableCollectionMarshaler { get; set; } = new ObservableCollectionMarshaler();

        public WareHouseViewModel()
        {
            DataTable dataTable = sqlServerExtension.QueryTable("t_wh_warehouse");
            if (dataTable == null || dataTable.Rows.Count == 0) { return; }
            WareHouseAreaCollection.Clear();
            foreach (DataRow item in dataTable.Rows)
            {
                //WareHouseAreaCollection.Add(new WareHouseAreaViewModel(item["WareHouseCode"]?.ToString(), item["WareHouseName"]?.ToString()));
                observableCollectionMarshaler.AddItem(WareHouseAreaCollection, new WareHouseAreaViewModel(item["WareHouseCode"]?.ToString(), item["WareHouseName"]?.ToString()));
            }
        }
    }
}
