﻿using DeceiveBarcodeManagement.Model;
using MaxCommunication.DataBase.SQLServer;
using PropertyChanged;
using System.Collections.ObjectModel;
using System.Data;

namespace DeceiveBarcodeManagement.ViewModel
{
    [AddINotifyPropertyChangedInterface]
    public class BaseViewModel
    {
        public SQLServerExtension sqlServerExtension { get; set; } = new SQLServerExtension("server=.;uid=sa;pwd=123;database=PMS_KLDZ_6324");

        public ObservableCollection<ElectricMeterViewModel> ElectricCollection { get; set; } = new ObservableCollection<ElectricMeterViewModel>();

        public int RowIndex { get; set; }

        public BaseViewModel(int RowIndex)
        {
            this.RowIndex = RowIndex;
        }

        public BaseViewModel(string TableName, int RowIndex)
        {
            InitElectricCollection(TableName); this.RowIndex = RowIndex;
        }

        public void InitElectricCollection(string TableName)
        {
            ElectricCollection.Clear();
            DataTable dataTable = sqlServerExtension.QueryTable(TableName); sqlServerExtension.Disconnect();
            if (dataTable == null || dataTable.Rows.Count == 0) { return; }
            foreach (DataRow item in dataTable.Rows)
            {
                ElectricCollection.Add(new ElectricMeterViewModel(new ElectricMeterModel(item)));
            }
        }
    }
}
