﻿using CasunCommon.BaseUI;
using MaxCommunication.DataBase.SQLServer;
using System;
using System.Data;
using System.Windows.Forms;

namespace PMSUI.UI
{
    public partial class DeceiveManagerForm : CasunForm
    {
        public SQLServerExtension sqlServerExtension = new SQLServerExtension("server=.;uid=sa;pwd=123;database=PMS_KLDZ_6324");

        public DeceiveManagerForm()
        {
            InitializeComponent();
        }

        private void DeceiveManagerForm_Load(object sender, EventArgs e)
        {
            CasunUILib.DgvModel(dataGridView1); InitDataGrid();
        }

        private void InitDataGrid()
        {
            dataGridView1.Rows.Clear();
            DataTable dt = sqlServerExtension.QueryTable("PMS_Max_DeceiveManager");
            if (dt != null && dt.Rows.Count != 0)
            {
                foreach (DataRow item in dt.Rows)
                {
                    int Index = dataGridView1.Rows.Add();
                    dataGridView1.Rows[Index].Cells["ID"].Value = item["ID"]?.ToString();
                    dataGridView1.Rows[Index].Cells["WorkStationName"].Value = item["WorkStationName"]?.ToString();
                    dataGridView1.Rows[Index].Cells["FirstRoll"].Value = item["FirstRoll"]?.ToString();
                    dataGridView1.Rows[Index].Cells["SecondRoll"].Value = item["SecondRoll"]?.ToString();
                    dataGridView1.Rows[Index].Cells["DeceiveName"].Value = item["DeceiveName"]?.ToString();
                    dataGridView1.Rows[Index].Cells["DeceiveType"].Value = item["DeceiveType"]?.ToString();
                    dataGridView1.Rows[Index].Cells["Offset"].Value = item["Offset"]?.ToString();
                    dataGridView1.Rows[Index].Cells["Remark"].Value = item["Remark"]?.ToString();
                }
            }
            dataGridView1.Refresh();
        }

        private void button_Add_Click(object sender, EventArgs e)
        {
            if (ValidateInput())
            {
                string values = $"'{textBox_WorkStationName.Text}','{textBox_FirstRoll.Text}','{textBox_SecondRoll.Text}','{textBox_DeceiveName.Text}','{textBox_DeceiveType.Text}',{textBox_Offset.Text},'{textBox_Remark.Text}'";
                if (sqlServerExtension.AddRecord("PMS_Max_DeceiveManager", values))
                {
                    MessageBox.Show("添加成功！");
                }
                else
                {
                    MessageBox.Show("添加失败！");
                }
                InitDataGrid();
            }
        }

        private void button_Modify_Click(object sender, EventArgs e)
        {
            if (ValidateInput())
            {
                if (sqlServerExtension.UpdateRecord("PMS_Max_DeceiveManager", $"WorkStationName='{textBox_WorkStationName.Text}',FirstRoll='{textBox_FirstRoll.Text}',SecondRoll='{textBox_SecondRoll.Text}',DeceiveName = '{textBox_DeceiveName.Text}',DeceiveType={textBox_DeceiveType.Text},Offset = {textBox_Offset.Text},Remark='{textBox_Remark.Text}'", $"where ID = {textBox_ID.Text}"))
                {
                    MessageBox.Show("修改成功！");
                }
                else
                {
                    MessageBox.Show("修改失败！");
                }
                InitDataGrid();
            }
        }

        private void button_Delete_Click(object sender, EventArgs e)
        {
            if (sqlServerExtension.DeleteRecord("PMS_Max_DeceiveManager", $"where ID={textBox_ID.Text}"))
            {
                MessageBox.Show("删除成功！");
            }
            else
            {
                MessageBox.Show("删除失败！");
            }
            InitDataGrid();
        }

        private void dataGridView1_CellMouseClick(object sender, DataGridViewCellMouseEventArgs e)
        {
            if (e.RowIndex != -1)
            {
                textBox_ID.Text = dataGridView1.Rows[e.RowIndex].Cells["ID"].Value.ToString();
                textBox_WorkStationName.Text = dataGridView1.Rows[e.RowIndex].Cells["WorkStationName"].Value.ToString();
                textBox_FirstRoll.Text = dataGridView1.Rows[e.RowIndex].Cells["FirstRoll"].Value.ToString();
                textBox_SecondRoll.Text = dataGridView1.Rows[e.RowIndex].Cells["SecondRoll"].Value.ToString();
                textBox_DeceiveName.Text = dataGridView1.Rows[e.RowIndex].Cells["DeceiveName"].Value.ToString();
                textBox_DeceiveType.Text = dataGridView1.Rows[e.RowIndex].Cells["DeceiveType"].Value.ToString();
                textBox_Offset.Text = dataGridView1.Rows[e.RowIndex].Cells["Offset"].Value.ToString();
                textBox_Remark.Text = dataGridView1.Rows[e.RowIndex].Cells["Remark"].Value.ToString();
            }
        }

        private bool ValidateInput()
        {
            if (textBox_WorkStationName.Text.Length == 0)
            {
                MessageBox.Show("请填写工位名称！");
                return false;
            }
            if (textBox_FirstRoll.Text.Length == 0)
            {
                MessageBox.Show("请填写第一滚筒位置！");
                return false;
            }
            if (textBox_SecondRoll.Text.Length == 0)
            {
                MessageBox.Show("请填写第二滚筒位置！");
                return false;
            }
            if (textBox_FirstRoll.Text.Length == 0)
            {
                MessageBox.Show("请填写设备名称！");
                return false;
            }
            if (textBox_DeceiveType.Text.Length == 0)
            {
                MessageBox.Show("请填写设备类型！");
                return false;
            }
            if (textBox_Offset.Text.Length == 0)
            {
                MessageBox.Show("请填写地址偏移量！");
                return false;
            }
            return true;
        }
    }
}
