﻿using CasunCommon.SystemLog;
using HslCommunication;
using HslCommunication.Profinet.Siemens;
using MaxCommunication.DataBase.SQLServer;
using Pms.UserEvent.Config;
using System;
using System.Data.SqlClient;
using System.Threading;
using System.Threading.Tasks;

namespace Pms.UserEvent.Communication
{
    public class TransportCommunication
    {
        public SQLServerExtension sqlServerExtension = new SQLServerExtension(CConfigManager.gs_globalConfig.WMSDataBaseUrl);

        public SiemensS7Net siemensS7 { get; set; }

        public string StartAddress { get; set; } = "DB10.200.4";

        public ushort Number { get; set; } = 31;

        public TransportCommunication(string Ip, int Port)
        {
            siemensS7 = new SiemensS7Net(SiemensPLCS.S1200, Ip); 
            siemensS7.Port = Port;
            Task.Factory.StartNew(UpdateWareHouseStatus);
        }

        public bool ReadBool(string Address)
        {
            OperateResult<bool> operateResult = siemensS7.ReadBool(Address);
            if (operateResult.IsSuccess)
            {
                CLog.Instance.WriteLog("ReadBool_PLC", $"PLC地址:[{Address}]，读取值:[{operateResult.Content}]");
                return operateResult.Content;
            }
            return false;
        }

        public bool WriteBool(string Address, bool value)
        {
            if (siemensS7.Write(Address, value).IsSuccess)
            {
                CLog.Instance.WriteLog("WriteBool_PLC", $"PLC地址:[{Address}]，写入值:[{value}]");
                return true;
            }
            return false;
        }

        public void UpdateWareHouseStatus()
        {
            while (true)
            {
                try
                {
                    //OperateResult<bool[]> operateResult = siemensS7.ReadBool(StartAddress, Number);
                    //if (operateResult.IsSuccess)
                    //{
                    //    string WareHouseStatus = "";
                    //    foreach (var item in operateResult.Content)
                    //    {
                    //        WareHouseStatus = WareHouseStatus + (item ? "1" : "2");
                    //    }
                    //    SqlParameter[] sqlParameter = new SqlParameter[1] { new SqlParameter("@WareHouseStatusArray", WareHouseStatus) };
                    //    sqlServerExtension.ExecuteProcedure("UpdateWareHouseStatus", sqlParameter); 
                    //}
                    //else
                    //{
                    //    CLog.Instance.WriteLog("TransPortAlarmLog", "中控连接输送线PLC失败！");
                    //}
                }
                catch (Exception ex)
                {
                    siemensS7.ConnectServer();
                    CLog.Instance.WriteLog("TransPortAlarmLog", "中控读取PLC库位状态，更新库位失败：" + ex.ToString());
                }
                Thread.Sleep(1000);
            }
        }
    }
}
