﻿using CasunCommon.SystemLog;
using MaxCommunication.DataBase.SQLServer;
using Pms.InternalInterface.Controllers;
using Pms.InternalInterface.Enums;
using Pms.UserEvent.Service;
using System;
using System.Collections.Generic;
using System.Text;

namespace Pms.UserEvent.Communication
{
    public class VcuCommunication
    {
        public CCarrierController.TransDataReceiveHandler handle = new CCarrierController.TransDataReceiveHandler(DataReceiveHandler);

        public static TrayBarcodeService trayBarcodeService { get; set; }

        public VcuCommunication(string ConnectString)
        {
            
            trayBarcodeService = new TrayBarcodeService(ConnectString);
            CPmsControllers.Instance.CarrierController.RegisterTransparentDataReceive(handle, out int Agvsfailcode, out EFailCode failCode);
        }
        public static bool DataReceiveHandler(byte[] data, int len)
        {
            try
            {
                CLog.Instance.WriteLog("VcuBarcodeLog", BitConverter.ToString(data) + "\n");
                if (data[0] == 0x25 && data.Length - 8 == data[6] * 0x100 + data[5])
                {
                    int CarID = data[2] * 0x100 + data[1];
                    var list = new List<byte>(data); list.RemoveRange(0, 15);
                    string Barcode = Encoding.ASCII.GetString(list.ToArray(), 0, list.IndexOf(0x0D));
                    if (data[3] == 1)
                    {
                        CLog.Instance.WriteLog("VcuBarcodeLog", "扫托盘码:" + Barcode + "\n");
                        if (trayBarcodeService.GetTrayBarcode(Barcode) == null)
                        {
                            trayBarcodeService.ClearAgvRecord(CarID);
                            trayBarcodeService.AddTrayBarcode(Barcode, CarID);
                        }
                        else
                        {
                            trayBarcodeService.ClearAgvRecord(CarID);
                            trayBarcodeService.UpdateAgvRecord(CarID, Barcode);
                        }
                    }
                    else if (data[3] == 2)
                    {
                        int Row = data[4] & 0x0F;
                        Row = Row == 8 ? 4 : Row == 4 ? 3 : Row == 2 ? 2 : Row == 1 ? 1 : 0;
                        CLog.Instance.WriteLog("VcuBarcodeLog", "扫表码:" + Barcode +",行数:"+ Row+ "\n");
                        string[] codes = Barcode.Split(',');
                        if (codes != null && codes.Length > 0)
                        {
                            if (codes.Length == 3)
                            {
                                if (Row > 0)
                                {
                                    for (int i = 0; i < codes.Length; i++)
                                    {
                                        trayBarcodeService.UpdateTrayBarcode(codes[i], i + 1 + 3 * (Row - 1), CarID);
                                    }
                                }
                            }
                            else if(codes.Length == 2)
                            {
                                for (int i = 0; i < codes.Length; i++)
                                {
                                    if (Row > 1)
                                    {
                                        trayBarcodeService.UpdateTrayBarcode(codes[i], i + 1+ 2 * (Row - 1), CarID);//trayBarcodeService.UpdateTrayBarcode(codes[i], i + 2+ 2 * (Row - 1), CarID);
                                    }
                                    else
                                    {
                                        trayBarcodeService.UpdateTrayBarcode(codes[i], i + 1, CarID);
                                    }
                                }
                            }
                            else
                            {
                                for (int i = 0; i < codes.Length; i++)
                                {
                                    //if (i > 1)
                                    //{
                                    //    trayBarcodeService.UpdateTrayBarcode(codes[i], i + 2, CarID);
                                    //}
                                    //else
                                    {
                                        trayBarcodeService.UpdateTrayBarcode(codes[i], i + 1, CarID);
                                    }
                                }
                            }
                        }

                        //int Row = data[4] & 0x0F; int Column = (data[4] & 0x70) >> 4;
                        //Row = Row == 8 ? 4 : Row == 4 ? 3 : Row == 2 ? 2 : Row == 1 ? 1 : 0;
                        //Column = Column == 8 ? 4 : Column == 4 ? 3 : Column == 2 ? 2 : Column == 1 ? 1 : 0;
                        //if (Row == 0 || Column == 0) { return true; }
                        //trayBarcodeService.UpdateTrayBarcode(Barcode, (Row * 3 - 3) + Column, CarID);
                    }
                }
                return true;
            }
            catch (Exception ex)
            {
                CLog.Instance.WriteLog("VcuBarcodeExceptionLog", ex.ToString());
                return true;
            }
        }
    }
}
