﻿using CasunCommon.SystemLog;
using HslCommunication;
using HslCommunication.Profinet.Siemens;

namespace Pms.UserEvent.Communication
{
    public class WareHouseCommunication
    {
        public static string WareHouse_In = "Storehouse_Enter";

        public static string WareHouse_Out = "Storehouse_Out";

        public SiemensS7Net siemensS7Net { get; set; }

        public WareHouseCommunication(string Ip, int Port) 
        {
            siemensS7Net = new SiemensS7Net(SiemensPLCS.S1200, Ip); siemensS7Net.Port = Port;
            if (!siemensS7Net.ConnectServer().IsSuccess)
            {
                CLog.Instance.WriteLog("WareHouseAlarmLog", "中控连接异常位PLC失败！");
            }
        }

        public bool ReadBool(string Address)
        {
            OperateResult<bool> operateResult = siemensS7Net.ReadBool(Address);
            if (operateResult.IsSuccess)
            {
                return operateResult.Content;
            }
            return false;
        }

        public bool WriteBool(string Address, bool Value)
        {
            lock (siemensS7Net)
            {
                OperateResult operateResult = siemensS7Net.Write(Address, Value);
                return operateResult.IsSuccess;
            }
        }
    }
}
