﻿using System;
using System.Collections.Generic;
using System.Data;

namespace Pms.UserEvent.Model
{
    public class MesEWTaskModel
    {
        public int TaskID { get; set; }

        public string TaskNo { get; set; }

        public string PileNo { get; set; }

        public string StationNo { get; set; }

        public int MaterialType { get; set; }

        public int TaskType { get; set; }

        public string TaskStatus { get; set; }

        public MesEWTaskModel(int TaskID, string TaskNo, string PileNo, string StationNo, int MaterialType, string TaskStatus)
        {
            this.TaskID = TaskID; this.TaskNo = TaskNo; this.PileNo = PileNo;
            this.StationNo = StationNo; this.MaterialType = MaterialType; this.TaskStatus = TaskStatus;
        }

        public MesEWTaskModel(DataRow dataRow)
        {
            TaskID = Convert.ToInt32(dataRow["ID"]?.ToString());
            TaskNo = dataRow["TaskNo"]?.ToString(); PileNo = dataRow["PileNo"]?.ToString();
            StationNo = dataRow["StationNo"]?.ToString(); MaterialType = Convert.ToInt32(dataRow["MaterialType"]);
            TaskStatus = dataRow["TaskStatus"]?.ToString(); TaskType = Convert.ToInt32(dataRow["TaskType"]);
        }

        public static List<MesEWTaskModel> ToList(DataTable dataTable)
        {
            if (dataTable == null || dataTable.Rows.Count == 0) { return null; }
            List<MesEWTaskModel> MesTaskList = new List<MesEWTaskModel>();
            foreach (DataRow item in dataTable.Rows)
            {
                MesEWTaskModel mesTaskModel = new MesEWTaskModel(item);
                MesTaskList.Add(mesTaskModel);
            }
            return MesTaskList;
        }
    }
}
