﻿using System.Collections.Generic;

namespace Pms.UserEvent.Model
{
    /// <summary>
    /// Mes返回值
    /// </summary>
    public class MesResultModel
    {
        public string RESULT_FLAG { get; set; }

        public string ERROR_INFO { get; set; }

        public List<StationModel> STATION_STATE { get; set; } = new List<StationModel>();
    }

    /// <summary>
    /// 设备的状态
    /// </summary>
    public class StationModel
    {
        public string STATION_ID { get; set; }

        public string STATE { get; set; }
    }

    /// <summary>
    /// 上报接货、送货完成
    /// </summary>
    public class ReportMesModel
    {
        public string PILE_NO { get; set; }

        public string PLATFORM_NO { get; set; }

        public ReportMesModel(string PILE_NO, string PLATFORM_NO)
        {
            this.PILE_NO = PILE_NO; this.PLATFORM_NO = PLATFORM_NO;
        }
    }

    /// <summary>
    /// 上报托盘与电表的绑定关系
    /// </summary>
    public class BindTrayAndBarcodeModel
    {
        public string BOX_NO { get; set; }

        public List<string> METER_CODE { get; set; } = new List<string>();

        public BindTrayAndBarcodeModel(string BOX_NO)
        {
            this.BOX_NO = BOX_NO;
        }
    }

    /// <summary>
    /// 挂表完成
    /// </summary>
    public class PocketWatchFinishModel 
    {
        public string STATION_ID { get; set; }

        public List<RelationshipModel> METER { get; set; } = new List<RelationshipModel>();

        public PocketWatchFinishModel(string STATION_ID)
        {
            this.STATION_ID = STATION_ID;
        }
    }

    /// <summary>
    /// 电表与表位之间的关系
    /// </summary>
    public class RelationshipModel 
    {
        public string METER_ID { get; set; }

        public string METER_CODE { get; set; }

        public RelationshipModel(string METER_ID, string METER_CODE)
        {
            this.METER_ID = METER_ID; this.METER_CODE = METER_CODE == "ERROR" ? "" : METER_CODE;
        }
    }

    /// <summary>
    /// 摘表完成
    /// </summary>
    public class ExcerptWatchFinishModel
    {
        public string PILE_NO { get; set; }

        public string PILE_TYPE { get; set; } = "1";

        public string TASK_NO { get; set; }

        public List<TrayRelationshipModel> BOX { get; set; } = new List<TrayRelationshipModel>();

        public ExcerptWatchFinishModel(string PILE_NO, string TASK_NO)
        {
            this.PILE_NO = PILE_NO; this.TASK_NO = TASK_NO;
        }
    }

    /// <summary>
    /// 电表与托盘之间的关系
    /// </summary>
    public class TrayRelationshipModel
    {
        public string BOX_NO { get; set; }

        public List<RelationshipModel> METER { get; set; } = new List<RelationshipModel>();

        public TrayRelationshipModel(string BOX_NO)
        {
            this.BOX_NO = BOX_NO;
        }
    }
}
