﻿using Pms.UserEvent.EnumType;
using System;
using System.Collections.Generic;
using System.Data;

namespace Pms.UserEvent.Model
{
    public class WareHouseModel
    {
        public string LocationCode { get; set; }

        public string TaskNo { get; set; }

        public string PileNo { get; set; }

        public MaterialTypeEnum MaterialType { get; set; }

        public string Quantity { get; set; }

        public int LayerNumber { get; set; }

        public int TopLayerNumber { get; set; }

        public int BFinished { get; set; }

        public int Status { get; set; }

        public WareHouseModel(DataRow dataRow)
        {
            LocationCode = dataRow["LocationCode"]?.ToString();
            TaskNo = dataRow["Attribute1"]?.ToString(); PileNo = dataRow["Attribute2"]?.ToString();
            MaterialType = (MaterialTypeEnum)Convert.ToInt32(dataRow["Attribute3"]); Quantity = dataRow["Attribute4"]?.ToString();
            LayerNumber = Convert.ToInt32(dataRow["Attribute5"]); TopLayerNumber = Convert.ToInt32(dataRow["Attribute6"]);
            BFinished = Convert.ToInt32(dataRow["Attribute7"]); Status = Convert.ToInt32(dataRow["Status"]);
        }

        public static List<WareHouseModel> ToList(DataTable dataTable)
        {
            List<WareHouseModel> wareHouseList = new List<WareHouseModel>();
            if (dataTable == null || dataTable.Rows.Count == 0) { return null; }
            foreach (DataRow item in dataTable.Rows)
            {
                WareHouseModel wareHouse = new WareHouseModel(item);
                wareHouseList.Add(wareHouse);
            }
            return wareHouseList;
        }
    }
}
