﻿using System;
using System.Collections.Generic;
using System.Data;

namespace Pms.UserEvent.Model
{
    public class WorkOrderModel
    {
        public string WorkOrderID { get; set; }

        public int TaskStatus { get; set; }

        public int TaskNumber { get; set; }

        public int PocketWatchNumber { get; set; }

        public int ExcerptNumber { get; set; }

        public DateTime WorkOrderTime { get; set; }

        public WorkOrderModel()
        {

        }

        public WorkOrderModel(DataRow dataRow)
        {
            WorkOrderID = dataRow["WorkOrderID"]?.ToString(); WorkOrderTime = DateTime.Parse(dataRow["DateTime"]?.ToString());
            TaskStatus = Convert.ToInt32(dataRow["TaskStatus"]); TaskNumber = Convert.ToInt32(dataRow["TaskNumber"]);
            PocketWatchNumber = Convert.ToInt32(dataRow["PocketWatchNumber"]); ExcerptNumber = Convert.ToInt32(dataRow["ExcerptNumber"]);
        }

        public static List<WorkOrderModel> ToList(DataTable dataTable)
        {
            List<WorkOrderModel> WorkOrderList = new List<WorkOrderModel>();
            if (dataTable == null || dataTable.Rows.Count == 0) { return null; }
            foreach (DataRow item in dataTable.Rows)
            {
                WorkOrderList.Add(new WorkOrderModel(item));
            }
            return WorkOrderList;
        }
    }
}
