﻿using MaxCommunication.DataBase.SQLServer;
using Pms.UserEvent.Model;
using System.Collections.Generic;
using System.Data;
using System.Linq;

namespace Pms.UserEvent.Service
{
    public class CacheService
    {
        public SQLServerExtension sqlServerExtension_Pms { get; set; }

        public CacheService(string ConnectString)
        {
            sqlServerExtension_Pms = new SQLServerExtension(ConnectString);
        }

        public void UpdateStoreFull(int CarID, int RowIndex, int[] ColumnIndex, string TaskNo, string[] Barcode, int Quantity)
        {
            for (int i = 0; i < ColumnIndex.Length; i++)
            {
                sqlServerExtension_Pms.UpdateRecord("PMS_Max_CacheTable", $"TaskNo = '{TaskNo}',Barcode = '{Barcode[i]}',Quantity = {Quantity},Status = 1",
                    $"where CarID = {CarID} and RowIndex = {RowIndex} and ColumnIndex = {ColumnIndex[i]}");
            }
            sqlServerExtension_Pms.Disconnect();
        }

        public void UpdateStoreEmpty(int CarID, int RowIndex)
        {
            sqlServerExtension_Pms.UpdateRecord("PMS_Max_CacheTable", $"TaskNo = '0',Barcode = '0',Quantity = 0,Status = 2",
               $"where CarID = {CarID} and RowIndex = {RowIndex}");
            sqlServerExtension_Pms.Disconnect();
        }

        public void UpdateStoreEmpty(int CarID, int RowIndex, int ColumnIndex)
        {
            sqlServerExtension_Pms.UpdateRecord("PMS_Max_CacheTable", $"TaskNo = '0',Barcode = '0',Quantity = 0,Status = 2",
                $"where CarID = {CarID} and RowIndex = {RowIndex} and ColumnIndex = {ColumnIndex}");
            sqlServerExtension_Pms.Disconnect();
        }

        public bool SearchEmptyStore(int CarID, int AmmeterNumber, string TaskNo, int Quantity, out int RowIndex, out int ColumnIndex)
        {
            DataTable dataTable = sqlServerExtension_Pms.QueryTable("PMS_Max_CacheTable", $"where CarID = {CarID}");
            sqlServerExtension_Pms.Disconnect(); if (dataTable == null || dataTable.Rows.Count == 0) { RowIndex = 0; ColumnIndex = 0; return false; }
            List<CacheModel> CacheList = CacheModel.ToList(dataTable);

            int RowIndex1 = 0, ColumnIndex1 = 0, RowIndex2 = 0, ColumnIndex2 = 0;

            List<CacheModel> CacheRow1EmptyList = CacheList.FindAll(t => t.RowIndex == 1 && t.Status == 2);
            List<CacheModel> CacheRow1FullList = CacheList.FindAll(t => t.RowIndex == 1 && t.Status == 1);

            List<CacheModel> CacheRow2EmptyList = CacheList.FindAll(t => t.RowIndex == 2 && t.Status == 2);
            List<CacheModel> CacheRow2FullList = CacheList.FindAll(t => t.RowIndex == 2 && t.Status == 1);


            if (CacheRow1EmptyList != null && CacheRow1EmptyList.Count >= AmmeterNumber)
            {
                if (CacheRow1FullList != null && CacheRow1FullList.Count != 0)
                {
                    if (CacheRow1FullList.Find(t => t.TaskNo == TaskNo && t.Quantity == Quantity) != null)
                    {
                        RowIndex1 = 1; ColumnIndex1 = CacheRow1EmptyList.Min(t => t.ColumnIndex); 
                    }
                }
                else
                {
                    RowIndex1 = 1; ColumnIndex1 = 1; 
                }
            }

           
            if (CacheRow2EmptyList != null && CacheRow2EmptyList.Count >= AmmeterNumber)
            {
                if (CacheRow2FullList != null && CacheRow2FullList.Count != 0)
                {
                    if (CacheRow2FullList.Find(t => t.TaskNo == TaskNo && t.Quantity == Quantity) != null)
                    {
                        RowIndex2 = 2; ColumnIndex2 = CacheRow2EmptyList.Min(t => t.ColumnIndex);
                    }
                }
                else
                {
                    RowIndex2 = 2; ColumnIndex2 = 1; 
                }
            }

            if (RowIndex1 != 0 && RowIndex2 != 0)
            {
                RowIndex = ColumnIndex1 > ColumnIndex2 ? RowIndex1 : RowIndex2;
                ColumnIndex = ColumnIndex1 > ColumnIndex2 ? ColumnIndex1 : ColumnIndex2;
                return true;
            }
            else if (RowIndex1 != 0)
            {
                RowIndex = RowIndex1; ColumnIndex = ColumnIndex1; return true;
            }
            else if (RowIndex2 != 0)
            {
                RowIndex = RowIndex2; ColumnIndex = ColumnIndex2; return true;
            }
            else
            {
                RowIndex = 0; ColumnIndex = 0; return false;
            }
        }

        public bool SearchFullStore(int CarID, int AmmeterNumber, string TaskNo, int Quantity, out int RowIndex, out int ColumnIndex)
        {
            DataTable dataTable = sqlServerExtension_Pms.QueryTable("PMS_Max_CacheTable", $"where CarID = {CarID}");
            sqlServerExtension_Pms.Disconnect(); if (dataTable == null || dataTable.Rows.Count == 0) { RowIndex = 0; ColumnIndex = 0; return false; }
            List<CacheModel> CacheList = CacheModel.ToList(dataTable);

            int RowIndex1 = 0, ColumnIndex1 = 0, RowIndex2 = 0, ColumnIndex2 = 0;

            List<CacheModel> CacheRow1EmptyList = CacheList.FindAll(t => t.RowIndex == 1 && t.Status == 2);
            List<CacheModel> CacheRow1FullList = CacheList.FindAll(t => t.RowIndex == 1 && t.Status == 1);

            List<CacheModel> CacheRow2EmptyList = CacheList.FindAll(t => t.RowIndex == 2 && t.Status == 2);
            List<CacheModel> CacheRow2FullList = CacheList.FindAll(t => t.RowIndex == 2 && t.Status == 1);


            if (CacheRow1FullList != null && CacheRow1FullList.Count >= AmmeterNumber)
            {
                if (CacheRow1EmptyList != null && CacheRow1EmptyList.Count != 0)
                {
                    //if (CacheRow1EmptyList.Find(t => t.TaskNo == TaskNo && t.Quantity == Quantity) != null)
                    {
                        RowIndex1 = 1; ColumnIndex1 = CacheRow1EmptyList.Min(t => t.ColumnIndex);
                    }
                }
                //else
                //{
                //    RowIndex1 = 1; ColumnIndex1 = 1;
                //}
            }


            if (CacheRow2FullList != null && CacheRow2FullList.Count >= AmmeterNumber)
            {
                if (CacheRow2EmptyList != null && CacheRow2EmptyList.Count != 0)
                {
                    //if (CacheRow2EmptyList.Find(t => t.TaskNo == TaskNo && t.Quantity == Quantity) != null)
                    {
                        RowIndex2 = 2; ColumnIndex2 = CacheRow2EmptyList.Min(t => t.ColumnIndex);
                    }
                }
                //else
                //{
                //    RowIndex2 = 2; ColumnIndex2 = 1;
                //}
            }

            if (RowIndex1 != 0 && RowIndex2 != 0)
            {
                RowIndex = ColumnIndex1 > ColumnIndex2 ? RowIndex1 : RowIndex2;
                ColumnIndex = ColumnIndex1 > ColumnIndex2 ? ColumnIndex1 : ColumnIndex2;
                return true;
            }
            else if (RowIndex1 != 0)
            {
                RowIndex = RowIndex1; ColumnIndex = ColumnIndex1; return true;
            }
            else if (RowIndex2 != 0)
            {
                RowIndex = RowIndex2; ColumnIndex = ColumnIndex2; return true;
            }
            else
            {
                RowIndex = 0; ColumnIndex = 0; return false;
            }
        }

        public bool SearchFullStore(int CarID, string TaskNo, int Quantity, out int RowIndex, out string[] Barcode)
        {
           DataTable dataTable = sqlServerExtension_Pms.QueryTable("PMS_Max_CacheTable", $"where CarID = {CarID} and Status = 1 and TaskNo = '{TaskNo}' and Quantity = {Quantity}");
            sqlServerExtension_Pms.Disconnect(); if (dataTable == null || dataTable.Rows.Count == 0) { RowIndex = 0; Barcode = null; return false; }
            List<CacheModel> CacheList = CacheModel.ToList(dataTable).OrderBy(t => t.RowIndex).ThenBy(t => t.ColumnIndex).ToList();

            List<CacheModel> CacheList1 = CacheList.FindAll(t => t.RowIndex == 1);
            if (CacheList1 != null && CacheList1.Count == 3) { RowIndex = 1; Barcode = new string[] { CacheList1[0].Barcode, CacheList1[1].Barcode, CacheList1[2].Barcode }; return true; }

            List<CacheModel> CacheList2 = CacheList.FindAll(t => t.RowIndex == 2);
            if (CacheList2 != null && CacheList2.Count == 3) { RowIndex = 2; Barcode = new string[] { CacheList2[0].Barcode, CacheList2[1].Barcode, CacheList2[2].Barcode }; return true; }

            RowIndex = 0; Barcode = null; return false;
        }

        //20220607 add
        public bool SearchRemainStore(int CarID, string TaskNo, int Quantity, out int RowIndex, out string[] Barcode)
        {
            DataTable dataTable = sqlServerExtension_Pms.QueryTable("PMS_Max_CacheTable", $"where CarID = {CarID} and Status = 1 and TaskNo = '{TaskNo}' and Quantity = {Quantity}");
            sqlServerExtension_Pms.Disconnect(); if (dataTable == null || dataTable.Rows.Count == 0) { RowIndex = 0; Barcode = null; return false; }
            List<CacheModel> CacheList = CacheModel.ToList(dataTable).OrderBy(t => t.RowIndex).ThenBy(t => t.ColumnIndex).ToList();

            List<CacheModel> CacheList1 = CacheList.FindAll(t => t.RowIndex == 1);
            if (CacheList1 != null && CacheList1.Count == 2) { RowIndex = 1; Barcode = new string[] { CacheList1[0].Barcode, CacheList1[1].Barcode }; return true; }
            if (CacheList1 != null && CacheList1.Count == 1) { RowIndex = 1; Barcode = new string[] { CacheList1[0].Barcode,}; return true; }

            List<CacheModel> CacheList2 = CacheList.FindAll(t => t.RowIndex == 2);
            if (CacheList2 != null && CacheList2.Count == 2) { RowIndex = 2; Barcode = new string[] { CacheList2[0].Barcode, CacheList2[1].Barcode }; return true; }
            if (CacheList2 != null && CacheList2.Count == 1) { RowIndex = 2; Barcode = new string[] { CacheList2[0].Barcode }; return true; }

            RowIndex = 0; Barcode = null; return false;
        }

        public bool JudgementJawsSite(int CarID, int PullNumber, string TaskNo, int Quantity, string[] Barcode, out int RowIndex, out int ColumnIndex, out int StartSite)
        {
            if (((PullNumber & 0x01) == 0x01 && (PullNumber & 0x02) == 0x02) || (PullNumber & 0x02) == 0x02 && (PullNumber & 0x04) == 0x04)
            {
                ///20220720 add
                if (SearchFullStore(CarID, 2, TaskNo, Quantity, out RowIndex, out ColumnIndex))
                {
                    switch (ColumnIndex)
                    {
                        case 3:
                            if ((PullNumber & 0x01) == 0x01) { ColumnIndex = 0x04; StartSite = 0x10; UpdateStoreFull(CarID, RowIndex, new int[] { 3 }, TaskNo, new string[] { Barcode[0]}, Quantity); return true; }
                            else if ((PullNumber & 0x02) == 0x02) { ColumnIndex = 0x04; StartSite = 0x08; UpdateStoreFull(CarID, RowIndex, new int[] { 3 }, TaskNo, new string[] { Barcode[1]}, Quantity); return true; }
                            break;

                    }
                }
                else if (SearchEmptyStore(CarID, 2, TaskNo, Quantity, out RowIndex, out ColumnIndex))
                {
                    switch (ColumnIndex)
                    {
                        case 1:
                            if ((PullNumber & 0x01) == 0x01) { ColumnIndex = 0x03; StartSite = 0x04; UpdateStoreFull(CarID, RowIndex, new int[] { 1, 2 }, TaskNo, new string[] { Barcode[0], Barcode[1] }, Quantity); return true; }
                            else if ((PullNumber & 0x02) == 0x02) { ColumnIndex = 0x06; StartSite = 0x02; UpdateStoreFull(CarID, RowIndex, new int[] { 1, 2 }, TaskNo, new string[] { Barcode[1], Barcode[2] }, Quantity); return true; }
                            break;

                        case 2:
                            if ((PullNumber & 0x01) == 0x01) { ColumnIndex = 0x03; StartSite = 0x08; UpdateStoreFull(CarID, RowIndex, new int[] { 2, 3 }, TaskNo, new string[] { Barcode[0], Barcode[1] }, Quantity); return true; }
                            else if ((PullNumber & 0x02) == 0x02) { ColumnIndex = 0x06; StartSite = 0x04; UpdateStoreFull(CarID, RowIndex, new int[] { 2, 3 }, TaskNo, new string[] { Barcode[1], Barcode[2] }, Quantity); return true; }
                            break;
                    }
                }
            }

            if ((PullNumber & 0x01) == 0x01 || (PullNumber & 0x02) == 0x02 || (PullNumber & 0x04) == 0x04)
            {
                if (SearchEmptyStore(CarID, 1, TaskNo, Quantity, out RowIndex, out ColumnIndex))
                {
                    switch (ColumnIndex)
                    {
                        case 1:
                            if ((PullNumber & 0x01) == 0x01) { ColumnIndex = 0x01; StartSite = 0x04; UpdateStoreFull(CarID, RowIndex, new int[] { 1 }, TaskNo, new string[] { Barcode[0] }, Quantity); return true; }
                            else if ((PullNumber & 0x02) == 0x02) { ColumnIndex = 0x02; StartSite = 0x02; UpdateStoreFull(CarID, RowIndex, new int[] { 1 }, TaskNo, new string[] { Barcode[1] }, Quantity); return true; }
                            else if ((PullNumber & 0x04) == 0x04) { ColumnIndex = 0x04; StartSite = 0x01; UpdateStoreFull(CarID, RowIndex, new int[] { 1 }, TaskNo, new string[] { Barcode[2] }, Quantity); return true; }
                            break;

                        case 2:
                            if ((PullNumber & 0x01) == 0x01) { ColumnIndex = 0x01; StartSite = 0x08; UpdateStoreFull(CarID, RowIndex, new int[] { 2 }, TaskNo, new string[] { Barcode[0] }, Quantity); return true; }
                            else if ((PullNumber & 0x02) == 0x02) { ColumnIndex = 0x02; StartSite = 0x04; UpdateStoreFull(CarID, RowIndex, new int[] { 2 }, TaskNo, new string[] { Barcode[1] }, Quantity); return true; }
                            else if ((PullNumber & 0x04) == 0x04) { ColumnIndex = 0x04; StartSite = 0x02; UpdateStoreFull(CarID, RowIndex, new int[] { 2 }, TaskNo, new string[] { Barcode[2] }, Quantity); return true; }
                            break;

                        case 3:
                            if ((PullNumber & 0x01) == 0x01) { ColumnIndex = 0x01; StartSite = 0x10; UpdateStoreFull(CarID, RowIndex, new int[] { 3 }, TaskNo, new string[] { Barcode[0] }, Quantity); return true; }
                            else if ((PullNumber & 0x02) == 0x02) { ColumnIndex = 0x02; StartSite = 0x08; UpdateStoreFull(CarID, RowIndex, new int[] { 3 }, TaskNo, new string[] { Barcode[1] }, Quantity); return true; }
                            else if ((PullNumber & 0x04) == 0x04) { ColumnIndex = 0x04; StartSite = 0x04; UpdateStoreFull(CarID, RowIndex, new int[] { 3 }, TaskNo, new string[] { Barcode[2] }, Quantity); return true; }
                            break;
                    }
                }
            }

            RowIndex = 0; ColumnIndex = 0; StartSite = 0; return false;
        }
    }
}
