﻿using MaxCommunication.DataBase.SQLServer;
using Pms.UserEvent.Config;
using Pms.UserEvent.Model;
using System.Data;

namespace Pms.UserEvent.Service
{
    public class CarService
    {
        public SQLServerExtension sqlServerExtension_Pms { get; set; }

        public CarService(string ConnectString)
        {
            sqlServerExtension_Pms = new SQLServerExtension(ConnectString);
        }

        public CarModel GetCar(int CarID)
        {
            DataTable dt_Car = sqlServerExtension_Pms.QueryTable("PMS_Max_Carrier", $"where CarID = {CarID}");
            if (dt_Car == null || dt_Car.Rows.Count == 0) { return null; }
            return new CarModel(dt_Car.Rows[0]);
        }

        public void UpdateFullCarRoll(CarModel carModel)
        {
            string content = $"TaskNo = '{carModel.TaskNo}',FirstPileNo = '{carModel.FirstPileNo}',SecondPileNo = '{carModel.SecondPileNo}'," +
                $"PocketNumber = {carModel.PocketNumber},PullNumber = {carModel.PullNumber}," +
                $"Barcode1 = '{carModel.Barcode1}',Barcode2 = '{carModel.Barcode2}',Barcode3 = '{carModel.Barcode3}'";
            content = content + $",FirstRollLayer = {carModel.FirstRollLayer},FirstTopLayerNumber = {carModel.FirstTopLayerNumber},FirstRollMaterialType = {carModel.FirstRollMaterialType},FirstRollMaterialQuantity = {carModel.FirstRollMaterialQuantity},FirstRollBFinished = {carModel.FirstRollBFinished}";
            content = content + $",SecondRollLayer = {carModel.SecondRollLayer},SecondTopLayerNumber = {carModel.SecondTopLayerNumber},SecondRollMaterialType = {carModel.SecondRollMaterialType},SecondRollMaterialQuantity = {carModel.SecondRollMaterialQuantity},SecondRollBFinished={carModel.SecondRollBFinished}";
            sqlServerExtension_Pms.UpdateRecord("PMS_Max_Carrier", content, $"where CarID = {carModel.CarID}");
            sqlServerExtension_Pms.Disconnect();
        }

        public void UpdateFullCarRoll(WareHouseModel wareHouseModel, int Site, int CarID)
        {
            string content = $"TaskNo = '{wareHouseModel.TaskNo}',";
            if (Site == 1)
            {
                content = content + $"FirstPileNo = '{wareHouseModel.PileNo}',FirstRollLayer = {wareHouseModel.LayerNumber},FirstTopLayerNumber = {wareHouseModel.TopLayerNumber},FirstRollMaterialType = {(int)wareHouseModel.MaterialType},FirstRollMaterialQuantity = {wareHouseModel.Quantity},FirstRollBFinished = {wareHouseModel.BFinished}";
            }
            else if (Site == 2)
            {
                content = content + $"SecondPileNo = '{wareHouseModel.PileNo}',SecondRollLayer = {wareHouseModel.LayerNumber},SecondTopLayerNumber = {wareHouseModel.TopLayerNumber},SecondRollMaterialType = {(int)wareHouseModel.MaterialType},SecondRollMaterialQuantity = {wareHouseModel.Quantity},SecondRollBFinished={wareHouseModel.BFinished}";
            }
            sqlServerExtension_Pms.UpdateRecord("PMS_Max_Carrier", content, $"where CarID = {CarID}");
            sqlServerExtension_Pms.Disconnect();
        }

        public void UpdateFullCarRoll(ExportModel exportModel, int Site, int CarID)
        {
            string content = $"TaskNo = '{exportModel.TaskNo}',";
            if (Site == 1)
            {
                content = content + $"FirstPileNo = '{exportModel.PileNo}',FirstRollLayer = {exportModel.LayerNumber},FirstTopLayerNumber = {exportModel.TopLayerNumber},FirstRollMaterialType = {exportModel.MaterialType},FirstRollMaterialQuantity = {exportModel.Quantity},FirstRollBFinished = {exportModel.BFinished}";
            }
            else if (Site == 2)
            {
                content = content + $"SecondPileNo = '{exportModel.PileNo}',SecondRollLayer = {exportModel.LayerNumber},SecondRollLayerNumber = {exportModel.TopLayerNumber},SecondRollMaterialType = {exportModel.MaterialType},SecondRollMaterialQuantity = {exportModel.Quantity},SecondRollBFinished={exportModel.BFinished}";
            }
            sqlServerExtension_Pms.UpdateRecord("PMS_Max_Carrier", content, $"where CarID = {CarID}");
            sqlServerExtension_Pms.Disconnect();
        }

        public void UpdateEmptyCarRoll(int CarID)
        {
            string content = $"FirstPileNo = '0',FirstRollLayer = 0,FirstTopLayerNumber = 0,FirstRollMaterialType = 0,FirstRollMaterialQuantity = 0,FirstRollBFinished = 0" +
                $"SecondPileNo = '0',SecondRollLayer = 0,SecondTopLayerNumber = 0,SecondRollMaterialType = 0,SecondRollMaterialQuantity = 0,SecondRollBFinished = 0";
            sqlServerExtension_Pms.UpdateRecord("PMS_Max_Carrier", content, $"where CarID = {CarID}");
            sqlServerExtension_Pms.Disconnect();
        }

        public void UpdateEmptyCarRoll(int CarID, int Site)
        {
            string content = "";
            if (Site == 1)
            {
                content = $"FirstPileNo = '0',FirstRollLayer = 0,FirstTopLayerNumber = 0,FirstRollMaterialType = 0,FirstRollMaterialQuantity = 0,FirstRollBFinished = 0";
            }
            else if (Site == 2)
            {
                content = $"SecondPileNo = '0',SecondRollLayer = 0,SecondTopLayerNumber = 0,SecondRollMaterialType = 0,SecondRollMaterialQuantity = 0,SecondRollBFinished = 0";
            }
            sqlServerExtension_Pms.UpdateRecord("PMS_Max_Carrier", content, $"where CarID = {CarID}");
            sqlServerExtension_Pms.Disconnect();
        }

        public void AddCarRecord(CarModel carModel)
        {
            string values = $"{carModel.CarID},'{carModel.TaskNo}',0,0,'0','0','0'" +
                $"{carModel.FirstRollLayer},'{carModel.FirstPileNo}',{carModel.FirstTopLayerNumber},{carModel.FirstRollMaterialType},{carModel.FirstRollMaterialQuantity},{carModel.SecondRollBFinished}," +
                $"{carModel.SecondRollLayer},'{carModel.SecondPileNo}',{carModel.SecondTopLayerNumber},{carModel.SecondRollMaterialType},{carModel.SecondRollMaterialQuantity},{carModel.SecondRollBFinished}";
            sqlServerExtension_Pms.AddRecord("PMS_Max_Carrier", values);
            sqlServerExtension_Pms.Disconnect();
        }

        public void AddCarRecord(WareHouseModel wareHouseModel, int Site, int CarID)
        {
            string values = $"{CarID},'{wareHouseModel.TaskNo}',0,0,'0','0','0',";
            if (Site == 1)
            {
                values = values + $"{wareHouseModel.LayerNumber},'{wareHouseModel.PileNo}',{wareHouseModel.TopLayerNumber},{(int)wareHouseModel.MaterialType},{wareHouseModel.Quantity},{wareHouseModel.BFinished},0,0,0,0,0,0";
            }
            else if (Site == 2)
            {
                values = values + $"0,0,0,0,0,0,{wareHouseModel.LayerNumber},'{wareHouseModel.PileNo}',{wareHouseModel.TopLayerNumber},{(int)wareHouseModel.MaterialType},{wareHouseModel.Quantity},{wareHouseModel.BFinished}";
            }
            sqlServerExtension_Pms.AddRecord("PMS_Max_Carrier", values);
            sqlServerExtension_Pms.Disconnect();
        }

        public void AddCarRecord(ExportModel exportModel, int Site, int CarID)
        {
            string values = $"{CarID},'{exportModel.TaskNo}',0,0,'0','0','0',";
            if (Site == 1)
            {
                values = values + $"{exportModel.LayerNumber},'{exportModel.PileNo}',{exportModel.TopLayerNumber},{exportModel.MaterialType},{exportModel.Quantity},{exportModel.BFinished},0,0,0,0,0,0";
            }
            else if (Site == 2)
            {
                values = values + $"0,0,0,0,0,0,{exportModel.LayerNumber},'{exportModel.PileNo}',{exportModel.TopLayerNumber},{exportModel.MaterialType},{exportModel.Quantity},{exportModel.BFinished}";
            }
            sqlServerExtension_Pms.AddRecord("PMS_Max_Carrier", values);
            sqlServerExtension_Pms.Disconnect();
        }
        public void DeleteCarRecord(int CarID)
        {
            sqlServerExtension_Pms.DeleteRecord("PMS_Max_Carrier", $"where CarID={CarID}");
            sqlServerExtension_Pms.Disconnect();
        }
    }
}
