﻿using MaxCommunication.DataBase.SQLServer;
using Pms.InternalInterface.Enums;
using Pms.InternalInterface.Models;
using Pms.UserEvent.Model;
using Pms.UserEvent.SystemEvent;
using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;

namespace Pms.UserEvent.Service
{
    public class DeceiveService
    {
        public SQLServerExtension sqlServerExtension_Pms { get; set; }

        public DeceiveService(string ConnectString)
        {
            sqlServerExtension_Pms = new SQLServerExtension(ConnectString);
        }

        public List<DeceiveModel> GetDeceiveModel(string DeceiveName)
        {
            string TableName = DeceiveName.Split('_').Length == 3 ? DeceiveName.Remove(DeceiveName.Length - 2, 2) : DeceiveName;
            DataTable dataTable = sqlServerExtension_Pms.QueryTable($"PMS_Max_{TableName}");
            return DeceiveModel.ToList(dataTable);
        }

        public string ToPmsName(string MesName)
        {
            DataTable dataTable = sqlServerExtension_Pms.QueryTable("PMS_Max_DeceiveManager", $"where DeceiveName = '{MesName}'");
            sqlServerExtension_Pms.Disconnect();
            if (dataTable != null && dataTable.Rows.Count != 0)
            {
                return dataTable.Rows[0]["WorkStationName"]?.ToString();
            }
            return null;
        }

        public string ToMesName(string PmsName)
        {
            DataTable dataTable = sqlServerExtension_Pms.QueryTable("PMS_Max_DeceiveManager", $"where FirstRoll = '{PmsName}' or SecondRoll = '{PmsName}' or WorkStationName = '{PmsName}'");
            sqlServerExtension_Pms.Disconnect();
            if (dataTable != null && dataTable.Rows.Count != 0)
            {
                return dataTable.Rows[0]["DeceiveName"]?.ToString();
            }
            return null;
        }

        public int GetMaterialType(string WorkStation)
        {
            DataTable dataTable = sqlServerExtension_Pms.QueryTable("PMS_Max_DeceiveManager", $"where FirstRoll = '{WorkStation}' or SecondRoll = '{WorkStation}'");
            sqlServerExtension_Pms.Disconnect();
            if (dataTable != null && dataTable.Rows.Count != 0)
            {
                return Convert.ToInt32(dataTable.Rows[0]["DeceiveType"]?.ToString());
            }
            return 0;
        }

        public int CanSinglePocketWatch(string DeceiveName)
        {
            int TaskPoint = Convert.ToInt32(DeceiveName.Split('_')[2]);
            string TableName = "PMS_Max_" + DeceiveName.Remove(DeceiveName.Length - 2, 2);
            DataTable dataTable = sqlServerExtension_Pms.QueryTable(TableName, $"where Status = 2");
            sqlServerExtension_Pms.Disconnect();
            List<DeceiveModel> deceiveList = DeceiveModel.ToList(dataTable);
            if (deceiveList == null || deceiveList.Count == 0) { return 0; }
            if (CSystemEvent.SingleWatchHoldingJaw == 3)
            {
                List<DeceiveModel> RowList1 = deceiveList.FindAll(t => t.RowIndex == 1 && t.ColumnIndex >= TaskPoint * 3 - 2 && t.ColumnIndex <= TaskPoint * 3);
                if (RowList1 != null && RowList1.Count == 3) { return 1; }

                List<DeceiveModel> RowList2 = deceiveList.FindAll(t => t.RowIndex == 2 && t.ColumnIndex >= TaskPoint * 3 - 2 && t.ColumnIndex <= TaskPoint * 3);
                if (RowList2 != null && RowList2.Count == 3) { return 2; }

                List<DeceiveModel> RowList3 = deceiveList.FindAll(t => t.RowIndex == 3 && t.ColumnIndex >= TaskPoint * 3 - 2 && t.ColumnIndex <= TaskPoint * 3);
                if (RowList3 != null && RowList3.Count == 3) { return 3; }
            }
            else
            {
                List<DeceiveModel> RowList1 = deceiveList.FindAll(t => t.RowIndex == 1 && t.ColumnIndex >= TaskPoint * 3 - 2 && t.ColumnIndex <= TaskPoint * 3);
                if (RowList1 != null && RowList1.Count >0) { return 1; }

                List<DeceiveModel> RowList2 = deceiveList.FindAll(t => t.RowIndex == 2 && t.ColumnIndex >= TaskPoint * 3 - 2 && t.ColumnIndex <= TaskPoint * 3);
                if (RowList2 != null && RowList2.Count >0) { return 2; }

                List<DeceiveModel> RowList3 = deceiveList.FindAll(t => t.RowIndex == 3 && t.ColumnIndex >= TaskPoint * 3 - 2 && t.ColumnIndex <= TaskPoint * 3);
                if (RowList3 != null && RowList3.Count >0) { return 3; }
            }

            return 0;
        }

        public bool CanSinglePocketWatch(string DeceiveName, out int RowIndex, out int ColumnIndex)
        {
            int TaskPoint = Convert.ToInt32(DeceiveName.Split('_')[2]);
            string TableName = "PMS_Max_" + DeceiveName.Remove(DeceiveName.Length - 2, 2);
            DataTable dataTable = sqlServerExtension_Pms.QueryTable(TableName, $"where Status = 2");
            sqlServerExtension_Pms.Disconnect();
            List<DeceiveModel> deceiveList = DeceiveModel.ToList(dataTable);
            if (deceiveList == null || deceiveList.Count == 0) { RowIndex = 0; ColumnIndex = 0; return false; }

            DeceiveModel deceiveModel = deceiveList.Find(t => t.RowIndex == 1 && t.ColumnIndex == TaskPoint * 3 - 2);
            if (deceiveModel != null) { RowIndex = 1; ColumnIndex = 1; return true; }

            deceiveModel = deceiveList.Find(t => t.RowIndex == 1 && t.ColumnIndex == TaskPoint * 3 - 1);
            if (deceiveModel != null) { RowIndex = 1; ColumnIndex = 2; return true; }

            deceiveModel = deceiveList.Find(t => t.RowIndex == 1 && t.ColumnIndex == TaskPoint * 3);
            if (deceiveModel != null) { RowIndex = 1; ColumnIndex = 4; return true; }

            deceiveModel = deceiveList.Find(t => t.RowIndex == 2 && t.ColumnIndex == TaskPoint * 3 - 2);
            if (deceiveModel != null) { RowIndex = 2; ColumnIndex = 1; return true; }

            deceiveModel = deceiveList.Find(t => t.RowIndex == 2 && t.ColumnIndex == TaskPoint * 3 - 1);
            if (deceiveModel != null) { RowIndex = 2; ColumnIndex = 2; return true; }

            deceiveModel = deceiveList.Find(t => t.RowIndex == 2 && t.ColumnIndex == TaskPoint * 3);
            if (deceiveModel != null) { RowIndex = 2; ColumnIndex = 4; return true; }

            deceiveModel = deceiveList.Find(t => t.RowIndex == 3 && t.ColumnIndex == TaskPoint * 3 - 2);
            if (deceiveModel != null) { RowIndex = 4; ColumnIndex = 1; return true; }

            deceiveModel = deceiveList.Find(t => t.RowIndex == 3 && t.ColumnIndex == TaskPoint * 3 - 1);
            if (deceiveModel != null) { RowIndex = 4; ColumnIndex = 2; return true; }

            deceiveModel = deceiveList.Find(t => t.RowIndex == 3 && t.ColumnIndex == TaskPoint * 3);
            if (deceiveModel != null) { RowIndex = 4; ColumnIndex = 4; return true; }




            RowIndex = 0; ColumnIndex = 0; return false;
        }

        public bool CanThreePocketWatch(string DeceiveName, out int RowIndex, out int ColumnIndex)
        {
            int TaskPoint = Convert.ToInt32(DeceiveName.Split('_')[2]);
            string TableName = "PMS_Max_" + DeceiveName.Remove(DeceiveName.Length - 2, 2);
            DataTable dataTable = sqlServerExtension_Pms.QueryTable(TableName, $"where Status = 2");
            sqlServerExtension_Pms.Disconnect();
            List<DeceiveModel> deceiveList = DeceiveModel.ToList(dataTable);
            if (deceiveList == null || deceiveList.Count == 0) { RowIndex = 0; ColumnIndex = 0; return false; }

            DeceiveModel deceiveModel = deceiveList.Find(t => t.RowIndex == 1 && t.ColumnIndex == TaskPoint * 2 - 1);
            if (deceiveModel != null) { RowIndex = 1; ColumnIndex = 1; return true; }

            deceiveModel = deceiveList.Find(t => t.RowIndex == 1 && t.ColumnIndex == TaskPoint * 2);
            if (deceiveModel != null) { RowIndex = 1; ColumnIndex = 2; return true; }

            deceiveModel = deceiveList.Find(t => t.RowIndex == 2 && t.ColumnIndex == TaskPoint * 2 - 1);
            if (deceiveModel != null) { RowIndex = 2; ColumnIndex = 1; return true; }

            deceiveModel = deceiveList.Find(t => t.RowIndex == 2 && t.ColumnIndex == TaskPoint * 2);
            if (deceiveModel != null) { RowIndex = 2; ColumnIndex = 2; return true; }

            RowIndex = 0; ColumnIndex = 0; return false;
        }

        public bool CanSingleExcerptWatchOK(string DeceiveName, string TaskNo, out string[] Barcode, out int RowIndex, out int ColumnIndex, out int ExcerptCount, int AllowMaxExcerptCount = 3)
        {
            ExcerptCount = 0;
            int TaskPoint = Convert.ToInt32(DeceiveName.Split('_')[2]);
            string TableName = "PMS_Max_" + DeceiveName.Remove(DeceiveName.Length - 2, 2);
            DataTable dataTable = sqlServerExtension_Pms.QueryTable(TableName, $"where Status = 1 and Quantity = 1 and TaskNo = '{TaskNo}'");
            sqlServerExtension_Pms.Disconnect();
            List<DeceiveModel> deceiveList = DeceiveModel.ToList(dataTable); Barcode = new string[3]; ColumnIndex = 0; RowIndex = 0;
            if (deceiveList == null || deceiveList.Count == 0) { Barcode = null; RowIndex = 0; ColumnIndex = 0; return false; }

            List<DeceiveModel> RowList1 = deceiveList.FindAll(t => t.RowIndex == 1 && t.ColumnIndex >= TaskPoint * 3 - 2 && t.ColumnIndex <= TaskPoint * 3);
            if (RowList1 != null && RowList1.Count != 0)
            {
                foreach (var item in RowList1)
                {
                    ExcerptCount++;
                    switch (item.ColumnIndex % 3)
                    {
                        //case 0:
                        //    Barcode[2] = item.Barcode; RowIndex = 1; ColumnIndex = ColumnIndex | 4;
                        //    break;
                        case 1:
                            Barcode[0] = item.Barcode; RowIndex = 1; ColumnIndex = ColumnIndex | 1;
                            break;
                        case 2:
                            Barcode[1] = item.Barcode; RowIndex = 1; ColumnIndex = ColumnIndex | 2;
                            break;
                        case 0:
                            Barcode[2] = item.Barcode; RowIndex = 1; ColumnIndex = ColumnIndex | 4;
                            break;
                    }
                    if (ExcerptCount >= AllowMaxExcerptCount)
                    {
                        return true;
                    }
                }
                return true;
            }

            List<DeceiveModel> RowList2 = deceiveList.FindAll(t => t.RowIndex == 2 && t.ColumnIndex >= TaskPoint * 3 - 2 && t.ColumnIndex <= TaskPoint * 3);
            if (RowList2 != null && RowList2.Count != 0)
            {
                foreach (var item in RowList2)
                {
                    ExcerptCount++;
                    switch (item.ColumnIndex % 3)
                    {
                        //case 0:
                        //    Barcode[2] = item.Barcode; RowIndex = 2; ColumnIndex = ColumnIndex | 4;
                        //    break;
                        case 1:
                            Barcode[0] = item.Barcode; RowIndex = 2; ColumnIndex = ColumnIndex | 1;
                            break;
                        case 2:
                            Barcode[1] = item.Barcode; RowIndex = 2; ColumnIndex = ColumnIndex | 2;
                            break;
                        case 0:
                            Barcode[2] = item.Barcode; RowIndex = 2; ColumnIndex = ColumnIndex | 4;
                            break;
                    }
                    if (ExcerptCount >= AllowMaxExcerptCount)
                    {
                        return true;
                    }
                }
                return true;
            }

            List<DeceiveModel> RowList3 = deceiveList.FindAll(t => t.RowIndex == 3 && t.ColumnIndex >= TaskPoint * 3 - 2 && t.ColumnIndex <= TaskPoint * 3);
            if (RowList3 != null && RowList3.Count != 0)
            {
                foreach (var item in RowList3)
                {
                    ExcerptCount++;
                    switch (item.ColumnIndex % 3)
                    {
                        //case 0:
                        //    Barcode[2] = item.Barcode; RowIndex = 4; ColumnIndex = ColumnIndex | 4;
                        //    break;
                        case 1:
                            Barcode[0] = item.Barcode; RowIndex = 4; ColumnIndex = ColumnIndex | 1;
                            break;
                        case 2:
                            Barcode[1] = item.Barcode; RowIndex = 4; ColumnIndex = ColumnIndex | 2;
                            break;
                        case 0:
                            Barcode[2] = item.Barcode; RowIndex = 4; ColumnIndex = ColumnIndex | 4;
                            break;
                    }
                    if (ExcerptCount >= AllowMaxExcerptCount)
                    {
                        return true;
                    }
                }
                return true;
            }

            Barcode = null; RowIndex = 0; ColumnIndex = 0; return false;
        }
        /// <summary>
        /// 是否还有要摘的NG表 20220620 add
        /// </summary>
        /// <param name="DeceiveName"></param>
        /// <param name="TaskNo"></param>
        /// <returns></returns>
        public bool HasExcerptWatchNG(string DeceiveName, string TaskNo)
        {
            string TableName = "PMS_Max_" + DeceiveName.Remove(DeceiveName.Length - 2, 2);
            DataTable dataTable = sqlServerExtension_Pms.QueryTable(TableName, $"where Status = 1 and Quantity = 2 and TaskNo = '{TaskNo}'");
            sqlServerExtension_Pms.Disconnect();
            List<DeceiveModel> deceiveList = DeceiveModel.ToList(dataTable);
            if (deceiveList == null || deceiveList.Count == 0) { return false; }
            return true;
        }
        /// <summary>
        /// 20220620 add
        /// </summary>
        /// <param name="DeceiveName"></param>
        /// <param name="TaskNo"></param>
        /// <returns></returns>
        public int GetCountWatchNG(string DeceiveName, string TaskNo)
        {
            string TableName = "PMS_Max_" + DeceiveName;//直接用台体库位
            DataTable dataTable = sqlServerExtension_Pms.QueryTable(TableName, $"where Status = 1 and Quantity = 2 and TaskNo = '{TaskNo}'");
            sqlServerExtension_Pms.Disconnect();
            List<DeceiveModel> deceiveList = DeceiveModel.ToList(dataTable);
            if (deceiveList == null || deceiveList.Count == 0) { return 0; }
            return deceiveList.Count;
        }
        public bool CanSingleExcerptWatchNG(string DeceiveName, string TaskNo, out string[] Barcode, out int RowIndex, out int ColumnIndex, out int ExcerptCount, int AllowMaxExcerptCount = 3)
        {
            ExcerptCount = 0;
            int TaskPoint = Convert.ToInt32(DeceiveName.Split('_')[2]);
            string TableName = "PMS_Max_" + DeceiveName.Remove(DeceiveName.Length - 2, 2);
            DataTable dataTable = sqlServerExtension_Pms.QueryTable(TableName, $"where Status = 1 and Quantity = 2 and TaskNo = '{TaskNo}'");
            sqlServerExtension_Pms.Disconnect();
            List<DeceiveModel> deceiveList = DeceiveModel.ToList(dataTable); Barcode = new string[3]; ColumnIndex = 0; RowIndex = 0;
            if (deceiveList == null || deceiveList.Count == 0) { Barcode = null; RowIndex = 0; ColumnIndex = 0; return false; }

            List<DeceiveModel> RowList1 = deceiveList.FindAll(t => t.RowIndex == 1 && t.ColumnIndex >= TaskPoint * 3 - 2 && t.ColumnIndex <= TaskPoint * 3);
            if (RowList1 != null && RowList1.Count != 0)
            {
                foreach (var item in RowList1)
                {
                    ExcerptCount++;
                    switch (item.ColumnIndex % 3)
                    {
                        //case 0:
                        //    Barcode[2] = item.Barcode; RowIndex = 1; ColumnIndex = ColumnIndex | 4;
                        //    break;
                        case 1:
                            Barcode[0] = item.Barcode; RowIndex = 1; ColumnIndex = ColumnIndex | 1;
                            break;
                        case 2:
                            Barcode[1] = item.Barcode; RowIndex = 1; ColumnIndex = ColumnIndex | 2;
                            break;
                        case 0:
                            Barcode[2] = item.Barcode; RowIndex = 1; ColumnIndex = ColumnIndex | 4;
                            break;
                    }
                    if (ExcerptCount >= AllowMaxExcerptCount)
                    {
                        return true;
                    }
                }
                return true;
            }

            List<DeceiveModel> RowList2 = deceiveList.FindAll(t => t.RowIndex == 2 && t.ColumnIndex >= TaskPoint * 3 - 2 && t.ColumnIndex <= TaskPoint * 3);
            if (RowList2 != null && RowList2.Count != 0)
            {
                foreach (var item in RowList2)
                {
                    ExcerptCount++;
                    switch (item.ColumnIndex % 3)
                    {
                        //case 0:
                        //    Barcode[2] = item.Barcode; RowIndex = 2; ColumnIndex = ColumnIndex | 4;
                        //    break;
                        case 1:
                            Barcode[0] = item.Barcode; RowIndex = 2; ColumnIndex = ColumnIndex | 1;
                            break;
                        case 2:
                            Barcode[1] = item.Barcode; RowIndex = 2; ColumnIndex = ColumnIndex | 2;
                            break;
                        case 0:
                            Barcode[2] = item.Barcode; RowIndex = 2; ColumnIndex = ColumnIndex | 4;
                            break;
                    }
                    if (ExcerptCount >= AllowMaxExcerptCount)
                    {
                        return true;
                    }
                }
                return true;
            }

            List<DeceiveModel> RowList3 = deceiveList.FindAll(t => t.RowIndex == 3 && t.ColumnIndex >= TaskPoint * 3 - 2 && t.ColumnIndex <= TaskPoint * 3);
            if (RowList3 != null && RowList3.Count != 0)
            {
                foreach (var item in RowList3)
                {
                    ExcerptCount++;
                    switch (item.ColumnIndex % 3)
                    {
                        //case 0:
                        //    Barcode[2] = item.Barcode; RowIndex = 4; ColumnIndex = ColumnIndex | 4;
                        //    break;
                        case 1:
                            Barcode[0] = item.Barcode; RowIndex = 4; ColumnIndex = ColumnIndex | 1;
                            break;
                        case 2:
                            Barcode[1] = item.Barcode; RowIndex = 4; ColumnIndex = ColumnIndex | 2;
                            break;
                        case 0:
                            Barcode[2] = item.Barcode; RowIndex = 4; ColumnIndex = ColumnIndex | 4;
                            break;
                    }
                    if (ExcerptCount >= AllowMaxExcerptCount)
                    {
                        return true;
                    }
                }
                return true;
            }
            Barcode = null; RowIndex = 0; ColumnIndex = 0; return false;
        }
        /// <summary>
        /// 是否还有要摘的OK表 20220620 add
        /// </summary>
        /// <param name="DeceiveName"></param>
        /// <param name="TaskNo"></param>
        /// <returns></returns>
        public bool HasExcerptWatchOK(string DeceiveName, string TaskNo)
        {
            string TableName = "PMS_Max_" + DeceiveName.Remove(DeceiveName.Length - 2, 2);
            DataTable dataTable = sqlServerExtension_Pms.QueryTable(TableName, $"where Status = 1 and Quantity = 1 and TaskNo = '{TaskNo}'");
            sqlServerExtension_Pms.Disconnect();
            List<DeceiveModel> deceiveList = DeceiveModel.ToList(dataTable);
            if (deceiveList == null || deceiveList.Count == 0) { return false; }
            return true;
        }
        /// <summary>
        /// 20220620 add
        /// </summary>
        /// <param name="DeceiveName"></param>
        /// <param name="TaskNo"></param>
        /// <returns></returns>
        public int GetCountWatchOK(string DeceiveName, string TaskNo)
        {
            string TableName = "PMS_Max_" + DeceiveName;//直接用台体库位
            DataTable dataTable = sqlServerExtension_Pms.QueryTable(TableName, $"where Status = 1 and Quantity = 1 and TaskNo = '{TaskNo}'");
            sqlServerExtension_Pms.Disconnect();
            List<DeceiveModel> deceiveList = DeceiveModel.ToList(dataTable);
            if (deceiveList == null || deceiveList.Count == 0) { return 0; }
            return deceiveList.Count;
        }
        public bool CanThreeExcerptWatchOK(string DeceiveName, string TaskNo, out string Barcode, out int RowIndex, out int ColumnIndex)
        {
            int TaskPoint = Convert.ToInt32(DeceiveName.Split('_')[2]);
            string TableName = "PMS_Max_" + DeceiveName.Remove(DeceiveName.Length - 2, 2);
            DataTable dataTable = sqlServerExtension_Pms.QueryTable(TableName, $"where Status = 1 and Quantity = 1 and TaskNo = '{TaskNo}'");
            sqlServerExtension_Pms.Disconnect();
            List<DeceiveModel> deceiveList = DeceiveModel.ToList(dataTable);
            if (deceiveList == null || deceiveList.Count == 0) { Barcode = null; RowIndex = 0; ColumnIndex = 0; return false; }

            DeceiveModel deceiveModel = deceiveList.Find(t => t.RowIndex == 1 && t.ColumnIndex == TaskPoint * 2 - 1);
            if (deceiveModel != null) { RowIndex = 1; ColumnIndex = 1; Barcode = deceiveModel.Barcode; return true; }

            deceiveModel = deceiveList.Find(t => t.RowIndex == 1 && t.ColumnIndex == TaskPoint * 2);
            if (deceiveModel != null) { RowIndex = 1; ColumnIndex = 2; Barcode = deceiveModel.Barcode; return true; }

            deceiveModel = deceiveList.Find(t => t.RowIndex == 2 && t.ColumnIndex == TaskPoint * 2 - 1);
            if (deceiveModel != null) { RowIndex = 2; ColumnIndex = 1; Barcode = deceiveModel.Barcode; return true; }

            deceiveModel = deceiveList.Find(t => t.RowIndex == 2 && t.ColumnIndex == TaskPoint * 2);
            if (deceiveModel != null) { RowIndex = 2; ColumnIndex = 2; Barcode = deceiveModel.Barcode; return true; }

            Barcode = null; RowIndex = 0; ColumnIndex = 0; return false;
        }

        public bool CanThreeExcerptWatchNG(string DeceiveName, string TaskNo, out string Barcode, out int RowIndex, out int ColumnIndex)
        {
            int TaskPoint = Convert.ToInt32(DeceiveName.Split('_')[2]);
            string TableName = "PMS_Max_" + DeceiveName.Remove(DeceiveName.Length - 2, 2);
            DataTable dataTable = sqlServerExtension_Pms.QueryTable(TableName, $"where Status = 1 and Quantity = 2 and TaskNo = '{TaskNo}'");
            sqlServerExtension_Pms.Disconnect();
            List<DeceiveModel> deceiveList = DeceiveModel.ToList(dataTable);
            if (deceiveList == null || deceiveList.Count == 0) { Barcode = null; RowIndex = 0; ColumnIndex = 0; return false; }

            DeceiveModel deceiveModel = deceiveList.Find(t => t.RowIndex == 1 && t.ColumnIndex == TaskPoint * 2 - 1);
            if (deceiveModel != null) { RowIndex = 1; ColumnIndex = 1; Barcode = deceiveModel.Barcode; return true; }

            deceiveModel = deceiveList.Find(t => t.RowIndex == 1 && t.ColumnIndex == TaskPoint * 2);
            if (deceiveModel != null) { RowIndex = 1; ColumnIndex = 2; Barcode = deceiveModel.Barcode; return true; }

            deceiveModel = deceiveList.Find(t => t.RowIndex == 2 && t.ColumnIndex == TaskPoint * 2 - 1);
            if (deceiveModel != null) { RowIndex = 2; ColumnIndex = 1; Barcode = deceiveModel.Barcode; return true; }

            deceiveModel = deceiveList.Find(t => t.RowIndex == 2 && t.ColumnIndex == TaskPoint * 2);
            if (deceiveModel != null) { RowIndex = 2; ColumnIndex = 2; Barcode = deceiveModel.Barcode; return true; }

            Barcode = null; RowIndex = 0; ColumnIndex = 0; return false;
        }

        public void UpdateSingleDeceiveBarcode(string DeceiveName, int RowIndex, int[] ColumnIndex, string[] Barcode, int Status, string TaskNo, int Quantity)
        {
            string TableName = "PMS_Max_" + DeceiveName.Remove(DeceiveName.Length - 2, 2);
            int TaskPoint = Convert.ToInt32(DeceiveName.Split('_')[2]);
            for (int i = 0; i < ColumnIndex.Length; i++)
            {
                if (ColumnIndex[i] > 0)
                {
                    sqlServerExtension_Pms.UpdateRecord(TableName, $"Barcode = '{Barcode[i]}',Status = {Status},Quantity = {Quantity},TaskNo = '{TaskNo}'", $"where RowIndex = {RowIndex} and ColumnIndex = {TaskPoint * 3 - 3 + ColumnIndex[i]}");
                }
            }
            sqlServerExtension_Pms.Disconnect();
        }


        public void UpdateSingleDeceiveBarcode(string DeceiveName, int RowIndex, int ColumnIndex, string Barcode, int Status, string TaskNo, int Quantity)
        {
            RowIndex = RowIndex > 2 ? 3 : RowIndex;
            ColumnIndex = ColumnIndex > 2 ? 3 : ColumnIndex;
            string TableName = "PMS_Max_" + DeceiveName.Remove(DeceiveName.Length - 2, 2);
            int TaskPoint = Convert.ToInt32(DeceiveName.Split('_')[2]);
            sqlServerExtension_Pms.UpdateRecord(TableName, $"Barcode = '{Barcode}',Status = {Status},TaskNo = '{TaskNo}',Quantity = {Quantity}", $"where RowIndex = {RowIndex} and ColumnIndex = {TaskPoint * 3 - 3 + ColumnIndex}");
            sqlServerExtension_Pms.Disconnect();
        }
        public void UpdateThreeDeceiveBarcode(string DeceiveName, int RowIndex, int ColumnIndex, string Barcode, int Status, string TaskNo, int Quantity)
        {
            string TableName = "PMS_Max_" + DeceiveName.Remove(DeceiveName.Length - 2, 2);
            int TaskPoint = Convert.ToInt32(DeceiveName.Split('_')[2]);
            sqlServerExtension_Pms.UpdateRecord(TableName, $"Barcode = '{Barcode}',Status = {Status},TaskNo = '{TaskNo}',Quantity = {Quantity}", $"where RowIndex = {RowIndex} and ColumnIndex = {TaskPoint * 2 - 2 + ColumnIndex}");
            sqlServerExtension_Pms.Disconnect();
        }



        //public bool JudgementSingleDeceiveHasNGWatch(string DeceiveName, int TaskType)
        //{
        //    DataTable dataTable = sqlServerExtension_Pms.QueryTable($"PMS_Max_{DeceiveName}");
        //    if (dataTable == null || dataTable.Rows.Count == 0) { return false; }
        //    List<DeceiveModel> DeceiveList = DeceiveModel.ToList(dataTable);

        //    if (TaskType == 1)
        //    {
        //        List<DeceiveModel> DeceiveList_AllOK = DeceiveList.FindAll(t => t.Quantity == 1);
        //        if (DeceiveList_AllOK == null && DeceiveList_AllOK.Count == 0) { return false; }
        //        foreach (var item in DeceiveList_AllOK)
        //        {
        //            switch (item.ColumnIndex % 3)
        //            {
        //                case 0:
        //                    var DeceiveList_AllOK_1 = DeceiveList_AllOK.FindAll(t => t.RowIndex == item.RowIndex && (t.ColumnIndex == item.ColumnIndex - 1 || t.ColumnIndex == item.ColumnIndex - 2));
        //                    if (DeceiveList_AllOK_1 != null && DeceiveList_AllOK_1.Count == 2) { return true; }
        //                    break;
        //                case 1:
        //                    var DeceiveList_AllOK_2 = DeceiveList_AllOK.FindAll(t => t.RowIndex == item.RowIndex && (t.ColumnIndex == item.ColumnIndex + 1 || t.ColumnIndex == item.ColumnIndex + 2));
        //                    if (DeceiveList_AllOK_2 != null && DeceiveList_AllOK.Count == 2) { return true; }
        //                    break;
        //                case 2:
        //                    var DeceiveList_AllOK_3 = DeceiveList_AllOK.FindAll(t => t.RowIndex == item.RowIndex && (t.ColumnIndex == item.ColumnIndex - 1 || t.ColumnIndex == item.ColumnIndex + 1));
        //                    if (DeceiveList_AllOK_3 != null && DeceiveList_AllOK.Count == 2) { return true; }
        //                    break;
        //            }
        //        }
        //        return false;
        //    }
        //    else if (TaskType == 2)
        //    {
        //        List<DeceiveModel> DeceiveList_Empty = DeceiveList.FindAll(t => t.Status == 2 || t.Barcode == "0");
        //        if (DeceiveList_Empty != null && DeceiveList_Empty.Count != 0) { return true; }

        //        List<DeceiveModel> DeceiveList_NG = DeceiveList.FindAll(t => t.Quantity == 2);
        //        foreach (var item in DeceiveList_NG)
        //        {
        //            switch (item.ColumnIndex % 3)
        //            {
        //                case 0:
        //                    var DeceiveList_NG_1 = DeceiveList_NG.FindAll(t => t.RowIndex == item.RowIndex && (t.ColumnIndex == item.ColumnIndex - 1 || t.ColumnIndex == item.ColumnIndex - 2));
        //                    if (DeceiveList_NG_1 != null && DeceiveList_NG_1.Count != 2) { return true; }
        //                    break;
        //                case 1:
        //                    var DeceiveList_NG_2 = DeceiveList_NG.FindAll(t => t.RowIndex == item.RowIndex && (t.ColumnIndex == item.ColumnIndex + 1 || t.ColumnIndex == item.ColumnIndex + 2));
        //                    if (DeceiveList_NG_2 != null && DeceiveList_NG_2.Count != 2) { return true; }
        //                    break;
        //                case 2:
        //                    var DeceiveList_NG_3 = DeceiveList_NG.FindAll(t => t.RowIndex == item.RowIndex && (t.ColumnIndex == item.ColumnIndex - 1 || t.ColumnIndex == item.ColumnIndex + 1));
        //                    if (DeceiveList_NG_3 != null && DeceiveList_NG_3.Count != 2) { return true; }
        //                    break;
        //            }
        //        }
        //    }
        //    else if (TaskType == 3)
        //    {
        //        List<DeceiveModel> DeceiveList_NG = DeceiveList.FindAll(t => t.Quantity == 2);
        //        if (DeceiveList_NG != null && DeceiveList_NG.Count != 0) { return true; }
        //    }
        //    return false;
        //}

        public bool JudgementDeceiveHasWatchToExcerpt(string DeceiveName, int TaskType, out string TaskNo)
        {
            TaskNo = "";
            DataTable dataTable = sqlServerExtension_Pms.QueryTable($"PMS_Max_{DeceiveName}");
            if (dataTable == null || dataTable.Rows.Count == 0) { return false; }
            List<DeceiveModel> DeceiveList = DeceiveModel.ToList(dataTable);

            if (TaskType == 1)
            {
                List<DeceiveModel> DeceiveList_OK = DeceiveList.FindAll(t => t.Quantity == 1);
                if (DeceiveList_OK != null && DeceiveList_OK.Count != 0) { TaskNo = DeceiveList_OK.First().TaskNo; return true; }

            }
            else if (TaskType == 2)
            {
                List<DeceiveModel> DeceiveList_NG = DeceiveList.FindAll(t => t.Quantity == 2);
                if (DeceiveList_NG != null && DeceiveList_NG.Count != 0) { TaskNo = DeceiveList_NG.First().TaskNo; return true; }

            }
            return false;
        }

        public int JudgementDeceiveIsPocketWatch(string DeceiveName, int MaterialType)
        {
            string TaskPoint = DeceiveName.Split('_').Length == 3 ? DeceiveName.Remove(DeceiveName.Length - 2, 2) : DeceiveName;
            int TaskLength = MaterialType == 1 ? 9 : 6;
            for (int i = 1; i <= TaskLength; i++)
            {
                if (MaterialType == 1)
                {
                    if (CanSinglePocketWatch(TaskPoint + "_" + i) != 0)
                    {
                        return i;
                    }
                }
                else
                {
                    if (CanThreePocketWatch(TaskPoint + "_" + i, out int RowIndex, out int ColumnIndex))
                    {
                        return i;
                    }
                }
            }
            return 0;
        }

        public int JudgementDeceiveIsExcerptWatch(string DeceiveName, int MaterialType, int TaskType, string TaskNo)
        {
            string TaskPoint = DeceiveName.Split('_').Length == 3 ? DeceiveName.Remove(DeceiveName.Length - 2, 2) : DeceiveName;
            int TaskLength = MaterialType == 1 ? 9 : 6;
            for (int i = 1; i <= TaskLength; i++)
            {
                if (MaterialType == 1)
                {
                    int tempAllowExcertCount = CSystemEvent.SingleWatchHoldingJaw == 3 ? 3 : 1;
                    if (TaskType == 1)
                    {
                        if (CanSingleExcerptWatchOK(TaskPoint + "_" + i, TaskNo, out string[] Barcode, out int RowIndex, out int ColumnIndex, out int ExcerptCount, tempAllowExcertCount))
                        {
                            return i;
                        }
                    }
                    else if (TaskType == 2)
                    {
                        if (CanSingleExcerptWatchNG(TaskPoint + "_" + i, TaskNo, out string[] Barcode, out int RowIndex, out int ColumnIndex, out int ExcerptCount, tempAllowExcertCount))
                        {
                            return i;
                        }
                    }
                }
                else
                {
                    if (TaskType == 1)
                    {
                        if (CanThreeExcerptWatchOK(TaskPoint + "_" + i, TaskNo, out string Barcode, out int RowIndex, out int ColumnIndex))
                        {
                            return i;
                        }
                    }
                    else if (TaskType == 2)
                    {
                        if (CanThreeExcerptWatchNG(TaskPoint + "_" + i, TaskNo, out string Barcode, out int RowIndex, out int ColumnIndex))
                        {
                            return i;
                        }
                    }
                }
            }
            return 0;
        }

        /// <summary>
        /// 是否可以产生任务
        /// </summary>
        /// <param name="DeceiveName">设备名称</param>
        /// <returns></returns>
        public bool JudgementDeceiveIsHasTask(string DeceiveName)
        {
            CPmsControllers.Instance.OrderDataController.GetOrderList($"OrderState <> 255 and PosArr like '%{ToPmsName(DeceiveName)}%'", "", out List<OrderData> OrderList, out EFailCode failCode);
            if (OrderList != null && OrderList.Count != 0)
            {
                return false;
            }
            return true;
        }
    }
}
