﻿using MaxCommunication.DataBase.SQLServer;
using Pms.UserEvent.Config;
using Pms.UserEvent.Model;
using System.Collections.Generic;
using System.Data;

namespace Pms.UserEvent.Service
{
    public class TrayBarcodeService
    {
        public SQLServerExtension sqLServerExtension { get; set; }

        public TrayBarcodeService(string ConnectString)
        {
            sqLServerExtension = new SQLServerExtension(CConfigManager.gs_globalConfig.PMSDataBaseUrl);
        }

        public TrayBarcodeModel GetTrayBarcode(string TrayBarcode)
        {
            DataTable dataTable = sqLServerExtension.QueryTable("PMS_Max_TrayBarcode", $"where TrayBarcode = '{TrayBarcode}' and CarID<>100");
            sqLServerExtension.Disconnect();
            if (dataTable == null || dataTable.Rows.Count == 0) { return null; }
            return new TrayBarcodeModel(dataTable.Rows[0]);
        }

        public TrayBarcodeModel GetTrayBarcode(int CarID)
        {
            DataTable dataTable = sqLServerExtension.QueryTable("PMS_Max_TrayBarcode", $"where CarID = {CarID}");
            sqLServerExtension.Disconnect();
            if (dataTable == null || dataTable.Rows.Count == 0) { return null; }
            return new TrayBarcodeModel(dataTable.Rows[0]);
        }
        public TrayBarcodeModel GetTrayBarcodeRemain(int CarID, string TrayBarcode) 
        {
            DataTable dataTable = sqLServerExtension.QueryTable("PMS_Max_TrayBarcode", $"where CarID = {CarID} and TrayBarcode = '{TrayBarcode}'");
            sqLServerExtension.Disconnect();
            if (dataTable == null || dataTable.Rows.Count == 0) { return null; }
            return new TrayBarcodeModel(dataTable.Rows[0]);
        }
        public TrayBarcodeModel GetTrayBarcodeByBarcodeRemain(int CarID, string Barcode)
        {
            DataTable dataTable = sqLServerExtension.QueryTable("PMS_Max_TrayBarcode", $"where CarID = {CarID} and (Barcode1 = '{Barcode}' or Barcode2 = '{Barcode}' or Barcode3 = '{Barcode}' or Barcode4 = '{Barcode}' or Barcode5 = '{Barcode}' or Barcode6 = '{Barcode}' or Barcode7 = '{Barcode}' or Barcode8 = '{Barcode}' or Barcode9 = '{Barcode}' or Barcode10 = '{Barcode}' or Barcode11 = '{Barcode}' or Barcode12 = '{Barcode}')");
            sqLServerExtension.Disconnect();
            if (dataTable == null || dataTable.Rows.Count == 0) { return null; }
            return new TrayBarcodeModel(dataTable.Rows[0]);
        }

        public List<TrayBarcodeModel> GetAllTrayBarcode(string TrayBarcode) 
        {
            List<TrayBarcodeModel> TrayBarcodeList = new List<TrayBarcodeModel>();
            string[] TrayBarcodeArr = TrayBarcode.Split('_'); if (TrayBarcodeArr.Length == 0) { return null; }
            TrayBarcode = $"'{TrayBarcodeArr[0]}'";
            for (int i = 1; i < TrayBarcodeArr.Length; i++)
            {
                TrayBarcode = TrayBarcode + "," + $"'{TrayBarcodeArr[i]}'";
            }
            DataTable dataTable = sqLServerExtension.QueryTable("PMS_Max_TrayBarcode", $"where TrayBarcode in ({TrayBarcode}) and CarID<>100");
            sqLServerExtension.Disconnect(); if (dataTable == null || dataTable.Rows.Count == 0) { return null; }
            foreach (DataRow item in dataTable.Rows)
            {
                TrayBarcodeList.Add(new TrayBarcodeModel(item));
            }
            return TrayBarcodeList;
        }

        public List<TrayBarcodeModel> GetAllTrayBarcodeRemain(string TrayBarcode)
        {
            List<TrayBarcodeModel> TrayBarcodeList = new List<TrayBarcodeModel>();
            string[] TrayBarcodeArr = TrayBarcode.Split('_'); if (TrayBarcodeArr.Length == 0) { return null; }
            TrayBarcode = $"'{TrayBarcodeArr[0]}'";
            for (int i = 1; i < TrayBarcodeArr.Length; i++)
            {
                TrayBarcode = TrayBarcode + "," + $"'{TrayBarcodeArr[i]}'";
            }
            DataTable dataTable = sqLServerExtension.QueryTable("PMS_Max_TrayBarcode", $"where TrayBarcode in ({TrayBarcode}) and CarID=100");
            sqLServerExtension.Disconnect(); if (dataTable == null || dataTable.Rows.Count == 0) { return null; }
            foreach (DataRow item in dataTable.Rows)
            {
                TrayBarcodeList.Add(new TrayBarcodeModel(item));
            }
            return TrayBarcodeList;
        }
        /// <summary>
        /// 判断要挂的表是否满垛
        /// </summary>
        /// <param name="TrayBarcode"></param>
        /// <returns></returns>
        public bool IsFullTrayBarcode(string TrayBarcode,int MaterialType)
        {
            List<TrayBarcodeModel> TrayBarcodeList = GetAllTrayBarcodeRemain(TrayBarcode);
            if(TrayBarcodeList!=null)
            {
                if(TrayBarcodeList.Count<6)
                {
                    return false;
                }
                foreach(var item in TrayBarcodeList)
                {
                    if (MaterialType == 1)
                    {
                        if (item.Barcode1 == "0" || item.Barcode2 == "0" || item.Barcode3 == "0"
                            || item.Barcode4 == "0" || item.Barcode5 == "0" || item.Barcode6 == "0"
                            || item.Barcode7 == "0" || item.Barcode8 == "0" || item.Barcode9 == "0"
                            || item.Barcode10 == "0" || item.Barcode11 == "0" || item.Barcode12 == "0")
                        {
                            return false;
                        }
                    }
                    else
                    {
                        if (item.Barcode1 == "0" || item.Barcode2 == "0" || item.Barcode3 == "0"
                               || item.Barcode4 == "0")
                        {
                            return false;
                        }

                    }
                }
            }
            return true;

        }

        public List<TrayBarcodeModel> GetAllTrayBarcodeRemain(int CarID)
        {
            List<TrayBarcodeModel> TrayBarcodeList = new List<TrayBarcodeModel>();
            DataTable dataTable = sqLServerExtension.QueryTable("PMS_Max_TrayBarcode", $"where CarID={CarID}");
            sqLServerExtension.Disconnect(); if (dataTable == null || dataTable.Rows.Count == 0) { return null; }
            foreach (DataRow item in dataTable.Rows)
            {
                TrayBarcodeList.Add(new TrayBarcodeModel(item));
            }
            return TrayBarcodeList;
        }

        public void UpdateTrayBarcodeRemain(TrayBarcodeModel trayBarcodeModel)
        {
            sqLServerExtension.UpdateRecord("PMS_Max_TrayBarcode",
                $"Barcode1 = '{trayBarcodeModel.Barcode1}',Barcode2 = '{trayBarcodeModel.Barcode2}',Barcode3 = '{trayBarcodeModel.Barcode3}'," +
                $"Barcode4 = '{trayBarcodeModel.Barcode4}',Barcode5 = '{trayBarcodeModel.Barcode5}',Barcode6 = '{trayBarcodeModel.Barcode6}'," +
                $"Barcode7 = '{trayBarcodeModel.Barcode7}',Barcode8 = '{trayBarcodeModel.Barcode8}',Barcode9 = '{trayBarcodeModel.Barcode9}'," +
                $"Barcode10 = '{trayBarcodeModel.Barcode10}',Barcode11 = '{trayBarcodeModel.Barcode11}',Barcode12 = '{trayBarcodeModel.Barcode12}'",
                $"where TrayBarcode = '{trayBarcodeModel.TrayBarcode}' and CarID=100");
            sqLServerExtension.Disconnect();
        }

        public void UpdateTrayBarcode(string Barcode, int Site, int CarID)
        {
            sqLServerExtension.UpdateRecord("PMS_Max_TrayBarcode", $"Barcode{Site} = '{Barcode}'", $"where CarID = '{CarID}'");
            sqLServerExtension.Disconnect();
        }

        public void UpdateTrayBarcode(string[] Barcode, int Site, int CarID)
        {
            for (int i = 0; i < Barcode.Length; i++)
            {
                sqLServerExtension.UpdateRecord("PMS_Max_TrayBarcode", $"Barcode{Site + i} = '{Barcode[i]}'", $"where CarID = '{CarID}'");
            }
            sqLServerExtension.Disconnect();
        }

        public void UpdateTrayBarcode(TrayBarcodeModel trayBarcodeModel)
        {
            sqLServerExtension.UpdateRecord("PMS_Max_TrayBarcode", 
                $"Barcode1 = '{trayBarcodeModel.Barcode1}',Barcode2 = '{trayBarcodeModel.Barcode2}',Barcode3 = '{trayBarcodeModel.Barcode3}'," +
                $"Barcode4 = '{trayBarcodeModel.Barcode4}',Barcode5 = '{trayBarcodeModel.Barcode5}',Barcode6 = '{trayBarcodeModel.Barcode6}'," +
                $"Barcode7 = '{trayBarcodeModel.Barcode7}',Barcode8 = '{trayBarcodeModel.Barcode8}',Barcode9 = '{trayBarcodeModel.Barcode9}'," +
                $"Barcode10 = '{trayBarcodeModel.Barcode10}',Barcode11 = '{trayBarcodeModel.Barcode11}',Barcode12 = '{trayBarcodeModel.Barcode12}'",
                $"where TrayBarcode = '{trayBarcodeModel.TrayBarcode}' and CarID<>100");
            sqLServerExtension.Disconnect();
        }

        public void AddTrayBarcode(string TrayBarcode, int CarID)
        {
            string values = $"{CarID},'{TrayBarcode}','0','0','0','0','0','0','0','0','0','0','0','0'";
            sqLServerExtension.AddRecord("PMS_Max_TrayBarcode", values); sqLServerExtension.Disconnect();
        }

        public void ClearAgvRecord(int CarID)
        {
            sqLServerExtension.UpdateRecord("PMS_Max_TrayBarcode", "CarID = 0", $"where CarID = {CarID}");
            sqLServerExtension.Disconnect();
        }

        public void UpdateAgvRecord(int CarID, string TrayBarcode)
        {
            sqLServerExtension.UpdateRecord("PMS_Max_TrayBarcode", $"CarID = {CarID}", $"where TrayBarcode = '{TrayBarcode}' and CarID<>100");
            sqLServerExtension.Disconnect();
        }

        public void DeleteTrayBarcode(string TrayBarcodeArr)
        {
            sqLServerExtension.DeleteRecord("PMS_Max_TrayBarcode", $"where TrayBarcode in ({TrayBarcodeArr})");
            sqLServerExtension.Disconnect();
        }

        public void DeleteEmptyTrayBarcode()
        {
            sqLServerExtension.DeleteRecord("PMS_Max_TrayBarcode", $"where Barcode1 = '0' and Barcode2 = '0' and Barcode3 = '0' and Barcode4 = '0' and Barcode5 = '0' and Barcode6 = '0' and Barcode7 = '0' and Barcode8 = '0' and Barcode9 = '0' and Barcode10 = '0' and Barcode11 = '0' and Barcode12 = '0'");
            sqLServerExtension.Disconnect();
        }

        public BindTrayAndBarcodeModel BindTrayAndBarcode(int CarID, int TopLayerNumber)
        {
            TrayBarcodeModel trayBarcodeModel = GetTrayBarcode(CarID);
            if (trayBarcodeModel != null)
            {
                List<string> listBarcode = new List<string>();
                BindTrayAndBarcodeModel bindTrayAndBarcodeModel = new BindTrayAndBarcodeModel(trayBarcodeModel.TrayBarcode);
                if (!string.IsNullOrWhiteSpace(trayBarcodeModel.Barcode1) && trayBarcodeModel.Barcode1 !="0")//&& trayBarcodeModel.Barcode1.ToLower() != "error"
                {
                    if(!string.IsNullOrEmpty(ClearErrorCode(trayBarcodeModel.Barcode1)))
                    {
                        listBarcode.Add(ClearErrorCode(trayBarcodeModel.Barcode1));
                    }
                    bindTrayAndBarcodeModel.METER_CODE.Add(ClearErrorCode(trayBarcodeModel.Barcode1));
                }
                if (!string.IsNullOrWhiteSpace(trayBarcodeModel.Barcode2) && trayBarcodeModel.Barcode2 != "0" )//&& trayBarcodeModel.Barcode2.ToLower() != "error"
                {
                    if (!string.IsNullOrEmpty(ClearErrorCode(trayBarcodeModel.Barcode2))&& listBarcode.Exists(p=>p== ClearErrorCode(trayBarcodeModel.Barcode2)))
                    {
                        bindTrayAndBarcodeModel.METER_CODE.Add("");
                    }
                    else
                    {
                        listBarcode.Add(ClearErrorCode(trayBarcodeModel.Barcode2));
                        bindTrayAndBarcodeModel.METER_CODE.Add(ClearErrorCode(trayBarcodeModel.Barcode2));
                    }
                    
                }
                if (!string.IsNullOrWhiteSpace(trayBarcodeModel.Barcode3) && trayBarcodeModel.Barcode3 != "0" )//&& trayBarcodeModel.Barcode4.ToLower() != "error"
                {
                    if (!string.IsNullOrEmpty(ClearErrorCode(trayBarcodeModel.Barcode3)) && listBarcode.Exists(p => p == ClearErrorCode(trayBarcodeModel.Barcode3)))
                    {
                        bindTrayAndBarcodeModel.METER_CODE.Add("");
                    }
                    else
                    {
                        listBarcode.Add(ClearErrorCode(trayBarcodeModel.Barcode3));
                        bindTrayAndBarcodeModel.METER_CODE.Add(ClearErrorCode(trayBarcodeModel.Barcode3));
                    }
                }
                if (!string.IsNullOrWhiteSpace(trayBarcodeModel.Barcode4) && trayBarcodeModel.Barcode4 != "0" )//&& trayBarcodeModel.Barcode5.ToLower() != "error"
                {
                    if (!string.IsNullOrEmpty(ClearErrorCode(trayBarcodeModel.Barcode4)) && listBarcode.Exists(p => p == ClearErrorCode(trayBarcodeModel.Barcode4)))
                    {
                        bindTrayAndBarcodeModel.METER_CODE.Add("");
                    }
                    else
                    {
                        listBarcode.Add(ClearErrorCode(trayBarcodeModel.Barcode4));
                        bindTrayAndBarcodeModel.METER_CODE.Add(ClearErrorCode(trayBarcodeModel.Barcode4));
                    }
                }
                if (TopLayerNumber == 12)
                {
                    if (!string.IsNullOrWhiteSpace(trayBarcodeModel.Barcode5) && trayBarcodeModel.Barcode5 != "0" )//&& trayBarcodeModel.Barcode3.ToLower() != "error"
                    {
                        if (!string.IsNullOrEmpty(ClearErrorCode(trayBarcodeModel.Barcode5)) && listBarcode.Exists(p => p == ClearErrorCode(trayBarcodeModel.Barcode5)))
                        {
                            bindTrayAndBarcodeModel.METER_CODE.Add("");
                        }
                        else
                        {
                            listBarcode.Add(ClearErrorCode(trayBarcodeModel.Barcode5));
                            bindTrayAndBarcodeModel.METER_CODE.Add(ClearErrorCode(trayBarcodeModel.Barcode5));
                        }
                    }
                    if (!string.IsNullOrWhiteSpace(trayBarcodeModel.Barcode6) && trayBarcodeModel.Barcode6 != "0") //&& trayBarcodeModel.Barcode6.ToLower() != "error"
                    {
                        if (!string.IsNullOrEmpty(ClearErrorCode(trayBarcodeModel.Barcode6)) && listBarcode.Exists(p => p == ClearErrorCode(trayBarcodeModel.Barcode6)))
                        {
                            bindTrayAndBarcodeModel.METER_CODE.Add("");
                        }
                        else
                        {
                            listBarcode.Add(ClearErrorCode(trayBarcodeModel.Barcode6));
                            bindTrayAndBarcodeModel.METER_CODE.Add(ClearErrorCode(trayBarcodeModel.Barcode6));
                        }
                    }
                    if (!string.IsNullOrWhiteSpace(trayBarcodeModel.Barcode7) && trayBarcodeModel.Barcode7 != "0")// && trayBarcodeModel.Barcode7.ToLower() != "error"
                    {
                        if (!string.IsNullOrEmpty(ClearErrorCode(trayBarcodeModel.Barcode7)) && listBarcode.Exists(p => p == ClearErrorCode(trayBarcodeModel.Barcode7)))
                        {
                            bindTrayAndBarcodeModel.METER_CODE.Add("");
                        }
                        else
                        {
                            listBarcode.Add(ClearErrorCode(trayBarcodeModel.Barcode7));
                            bindTrayAndBarcodeModel.METER_CODE.Add(ClearErrorCode(trayBarcodeModel.Barcode7));
                        }
                    }
                    if (!string.IsNullOrWhiteSpace(trayBarcodeModel.Barcode8) && trayBarcodeModel.Barcode8 != "0" )//&& trayBarcodeModel.Barcode8.ToLower() != "error"
                    {
                        if (!string.IsNullOrEmpty(ClearErrorCode(trayBarcodeModel.Barcode8)) && listBarcode.Exists(p => p == ClearErrorCode(trayBarcodeModel.Barcode8)))
                        {
                            bindTrayAndBarcodeModel.METER_CODE.Add("");
                        }
                        else
                        {
                            listBarcode.Add(ClearErrorCode(trayBarcodeModel.Barcode8));
                            bindTrayAndBarcodeModel.METER_CODE.Add(ClearErrorCode(trayBarcodeModel.Barcode8));
                        }
                    }
                    if (!string.IsNullOrWhiteSpace(trayBarcodeModel.Barcode9) && trayBarcodeModel.Barcode9 != "0" )//&& trayBarcodeModel.Barcode9.ToLower() != "error"
                    {
                        if (!string.IsNullOrEmpty(ClearErrorCode(trayBarcodeModel.Barcode9)) && listBarcode.Exists(p => p == ClearErrorCode(trayBarcodeModel.Barcode9)))
                        {
                            bindTrayAndBarcodeModel.METER_CODE.Add("");
                        }
                        else
                        {
                            listBarcode.Add(ClearErrorCode(trayBarcodeModel.Barcode9));
                            bindTrayAndBarcodeModel.METER_CODE.Add(ClearErrorCode(trayBarcodeModel.Barcode9));
                        }
                    }
                    if (!string.IsNullOrWhiteSpace(trayBarcodeModel.Barcode10) && trayBarcodeModel.Barcode10 != "0" )//&& trayBarcodeModel.Barcode10.ToLower() != "error"
                    {
                        if (!string.IsNullOrEmpty(ClearErrorCode(trayBarcodeModel.Barcode10)) && listBarcode.Exists(p => p == ClearErrorCode(trayBarcodeModel.Barcode10)))
                        {
                            bindTrayAndBarcodeModel.METER_CODE.Add("");
                        }
                        else
                        {
                            listBarcode.Add(ClearErrorCode(trayBarcodeModel.Barcode10));
                            bindTrayAndBarcodeModel.METER_CODE.Add(ClearErrorCode(trayBarcodeModel.Barcode10));
                        }
                    }
                    if (!string.IsNullOrWhiteSpace(trayBarcodeModel.Barcode11) && trayBarcodeModel.Barcode11 != "0" )//&& trayBarcodeModel.Barcode11.ToLower() != "error"
                    {
                        if (!string.IsNullOrEmpty(ClearErrorCode(trayBarcodeModel.Barcode11)) && listBarcode.Exists(p => p == ClearErrorCode(trayBarcodeModel.Barcode11)))
                        {
                            bindTrayAndBarcodeModel.METER_CODE.Add("");
                        }
                        else
                        {
                            listBarcode.Add(ClearErrorCode(trayBarcodeModel.Barcode11));
                            bindTrayAndBarcodeModel.METER_CODE.Add(ClearErrorCode(trayBarcodeModel.Barcode11));
                        }
                    }
                    if (!string.IsNullOrWhiteSpace(trayBarcodeModel.Barcode12) && trayBarcodeModel.Barcode12 != "0" )//&& trayBarcodeModel.Barcode12.ToLower() != "error"
                    {
                        if (!string.IsNullOrEmpty(ClearErrorCode(trayBarcodeModel.Barcode12)) && listBarcode.Exists(p => p == ClearErrorCode(trayBarcodeModel.Barcode12)))
                        {
                            bindTrayAndBarcodeModel.METER_CODE.Add("");
                        }
                        else
                        {
                            listBarcode.Add(ClearErrorCode(trayBarcodeModel.Barcode12));
                            bindTrayAndBarcodeModel.METER_CODE.Add(ClearErrorCode(trayBarcodeModel.Barcode12));
                        }
                    }
                }
                return bindTrayAndBarcodeModel;
            }
            return null;
        }

        public BindTrayAndBarcodeModel BindTrayAndBarcodeByBarType(int CarID, int BarType=3)
        {
            TrayBarcodeModel trayBarcodeModel = GetTrayBarcode(CarID);
            if (trayBarcodeModel != null)
            {
                BindTrayAndBarcodeModel bindTrayAndBarcodeModel = new BindTrayAndBarcodeModel(trayBarcodeModel.TrayBarcode);
                bindTrayAndBarcodeModel.METER_CODE.Add(ClearErrorCode(trayBarcodeModel.Barcode1));
                bindTrayAndBarcodeModel.METER_CODE.Add(ClearErrorCode(trayBarcodeModel.Barcode2));
                bindTrayAndBarcodeModel.METER_CODE.Add(ClearErrorCode(trayBarcodeModel.Barcode3));
                bindTrayAndBarcodeModel.METER_CODE.Add(ClearErrorCode(trayBarcodeModel.Barcode4));
                if (BarType == 1)
                {
                    bindTrayAndBarcodeModel.METER_CODE.Add(ClearErrorCode(trayBarcodeModel.Barcode5));
                    bindTrayAndBarcodeModel.METER_CODE.Add(ClearErrorCode(trayBarcodeModel.Barcode6));
                    bindTrayAndBarcodeModel.METER_CODE.Add(ClearErrorCode(trayBarcodeModel.Barcode7));
                    bindTrayAndBarcodeModel.METER_CODE.Add(ClearErrorCode(trayBarcodeModel.Barcode8));
                    bindTrayAndBarcodeModel.METER_CODE.Add(ClearErrorCode(trayBarcodeModel.Barcode9));
                    bindTrayAndBarcodeModel.METER_CODE.Add(ClearErrorCode(trayBarcodeModel.Barcode10));
                    bindTrayAndBarcodeModel.METER_CODE.Add(ClearErrorCode(trayBarcodeModel.Barcode11));
                    bindTrayAndBarcodeModel.METER_CODE.Add(ClearErrorCode(trayBarcodeModel.Barcode12));
                }
                return bindTrayAndBarcodeModel;
            }
            return null;
        }

        public string ClearErrorCode(string Barcode)
        {
            return Barcode == "ERROR" ? "" : Barcode;
        }
    }
}
