﻿using MaxCommunication.DataBase.SQLServer;
using Pms.UserEvent.Model;
using System.Data;

namespace Pms.UserEvent.Service
{
    public class WareHouseService
    {
        public SQLServerExtension sqlServerExtension_Wms { get; set; }

        public WareHouseService(string ConnectString)
        {
            sqlServerExtension_Wms = new SQLServerExtension(ConnectString);
        }
        public string SearchWareHouse7()
        {
            DataTable dt_WareHouse = sqlServerExtension_Wms.QueryTable("t_wh_locationProperty", $"where LocationCode = 'WareHouse_7' and Status = 2");
            if (dt_WareHouse == null || dt_WareHouse.Rows.Count == 0) { return null; }
            sqlServerExtension_Wms.UpdateRecord("t_wh_locationProperty", "status = 3", $"where LocationCode = '{dt_WareHouse.Rows[0]["LocationCode"]?.ToString()}'");
            sqlServerExtension_Wms.Disconnect();
            return dt_WareHouse.Rows[0]["LocationCode"]?.ToString();
        }

        public string SearchExceptionWareHouse()
        {
            DataTable dt_WareHouse = sqlServerExtension_Wms.QueryTable("t_wh_locationProperty", $"where LocationCode = 'WareHouse_100' and Status = 2");
            if (dt_WareHouse == null || dt_WareHouse.Rows.Count == 0) { return null; }
            sqlServerExtension_Wms.UpdateRecord("t_wh_locationProperty", "status = 3", $"where LocationCode = '{dt_WareHouse.Rows[0]["LocationCode"]?.ToString()}'");
            sqlServerExtension_Wms.Disconnect();
            return dt_WareHouse.Rows[0]["LocationCode"]?.ToString();
        }
        public string SearchEmptyWareHouse(int MaterialType)
        {
            int WareHouseNo = ExchangeMaterialType(MaterialType);
            DataTable dt_WareHouse = sqlServerExtension_Wms.QueryTable("t_wh_locationProperty", $"where WareHouseCode = 'WH00{WareHouseNo}' and Status = 2 and LocationCode <> 'WareHouse_7'");
            if (dt_WareHouse == null || dt_WareHouse.Rows.Count == 0) { return null; }
            sqlServerExtension_Wms.UpdateRecord("t_wh_locationProperty", "status = 3", $"where LocationCode = '{dt_WareHouse.Rows[0]["LocationCode"]?.ToString()}'");
            sqlServerExtension_Wms.Disconnect();
            return dt_WareHouse.Rows[0]["LocationCode"]?.ToString();
        }
        public void SearchEmptyWareHouse(string LocationCode)
        {
            sqlServerExtension_Wms.UpdateRecord("t_wh_locationProperty", "status = 3", $"where LocationCode = '{LocationCode}'");
            sqlServerExtension_Wms.Disconnect();
        }

        public string SearchEmptyTray(int MaterialType)
        {
            int WareHouseNo = ExchangeMaterialType(MaterialType);
            DataTable dt_WareHouse = sqlServerExtension_Wms.QueryTable("t_wh_locationProperty", $"where WareHouseCode = 'WH00{WareHouseNo}' and Status = 1 and Attribute6 = 0 and Attribute5 <> 0 order by Attribute5");//desc
            if (dt_WareHouse == null || dt_WareHouse.Rows.Count == 0) { return null; }
            sqlServerExtension_Wms.UpdateRecord("t_wh_locationProperty", "status = 3", $"where LocationCode = '{dt_WareHouse.Rows[0]["LocationCode"]?.ToString()}'");
            sqlServerExtension_Wms.Disconnect();
            return dt_WareHouse.Rows[0]["LocationCode"]?.ToString();
        }
        /// <summary>
        /// 获取缓存台满垛空箱
        /// </summary>
        /// <param name="MaterialType"></param>
        /// <returns></returns>
        public string SearchEmptyTrayFullPile(int MaterialType)
        {
            int WareHouseNo = ExchangeMaterialType(MaterialType);
            DataTable dt_WareHouse = sqlServerExtension_Wms.QueryTable("t_wh_locationProperty", $"where WareHouseCode = 'WH00{WareHouseNo}' and Status = 1 and Attribute6 = 0 and Attribute5 = 6 order by Attribute5");//desc
            if (dt_WareHouse == null || dt_WareHouse.Rows.Count == 0) { return null; }
            sqlServerExtension_Wms.UpdateRecord("t_wh_locationProperty", "status = 3", $"where LocationCode = '{dt_WareHouse.Rows[0]["LocationCode"]?.ToString()}'");
            sqlServerExtension_Wms.Disconnect();
            return dt_WareHouse.Rows[0]["LocationCode"]?.ToString();
        }

        public string SearchOKTray(int MaterialType, string TaskNo, out string TrayLayer,out int TopLayerNumber)
        {
            TrayLayer = "";
            TopLayerNumber = 0;
            int WareHouseNo = ExchangeMaterialType(MaterialType);
            DataTable dt_WareHouse = sqlServerExtension_Wms.QueryTable("t_wh_locationProperty", $"where WareHouseCode = 'WH00{WareHouseNo}' and Status = 1 and Attribute1 = '{TaskNo}' and Attribute3 = {MaterialType} and Attribute4 = 1 and Attribute6 <> 0 and Attribute7 = 1 order by Attribute5 desc");
            if (dt_WareHouse == null || dt_WareHouse.Rows.Count == 0) { return null; }
            sqlServerExtension_Wms.UpdateRecord("t_wh_locationProperty", "status = 3", $"where LocationCode = '{dt_WareHouse.Rows[0]["LocationCode"]?.ToString()}'");
            sqlServerExtension_Wms.Disconnect();
            TrayLayer = dt_WareHouse.Rows[0]["Attribute5"]?.ToString();
            string strTopLayerNumber= dt_WareHouse.Rows[0]["Attribute6"]?.ToString();
            int.TryParse(strTopLayerNumber,out TopLayerNumber);
            return dt_WareHouse.Rows[0]["LocationCode"]?.ToString();
        }

        public string SearchNGTray(int MaterialType, string TaskNo, out string TrayLayer, out int TopLayerNumber)
        {
            TrayLayer = "";
            TopLayerNumber = 0;
            int WareHouseNo = ExchangeMaterialType(MaterialType);
            DataTable dt_WareHouse = sqlServerExtension_Wms.QueryTable("t_wh_locationProperty", $"where WareHouseCode = 'WH00{WareHouseNo}' and Status = 1 and Attribute1 = '{TaskNo}' and Attribute3 = {MaterialType} and Attribute4 = 2 and Attribute6 <> 0 and Attribute7 = 1 order by Attribute5 desc");
            if (dt_WareHouse == null || dt_WareHouse.Rows.Count == 0) { return null; }
            sqlServerExtension_Wms.UpdateRecord("t_wh_locationProperty", "status = 3", $"where LocationCode = '{dt_WareHouse.Rows[0]["LocationCode"]?.ToString()}'");
            sqlServerExtension_Wms.Disconnect();
            TrayLayer = dt_WareHouse.Rows[0]["Attribute5"]?.ToString();
            string strTopLayerNumber = dt_WareHouse.Rows[0]["Attribute6"]?.ToString();
            int.TryParse(strTopLayerNumber, out TopLayerNumber);
            return dt_WareHouse.Rows[0]["LocationCode"]?.ToString();
        }

        public WareHouseModel GetWareHouseModel(string LocationCode)
        {
            DataTable dataTable = sqlServerExtension_Wms.QueryTable("t_wh_locationProperty", $"where LocationCode = '{LocationCode}'");
            sqlServerExtension_Wms.Disconnect();
            if (dataTable == null || dataTable.Rows.Count == 0) { return null; }
            return new WareHouseModel(dataTable.Rows[0]);
        }

        public void SetFullWareHouseModel(WareHouseModel wareHouseModel)
        {
            string content = $"status = 1,Attribute1='{wareHouseModel.TaskNo}',Attribute2='{wareHouseModel.PileNo}',Attribute3={(int)wareHouseModel.MaterialType}," +
                $"Attribute4 = {wareHouseModel.Quantity},Attribute5 = {wareHouseModel.LayerNumber},Attribute6 = {wareHouseModel.TopLayerNumber},Attribute7 = {wareHouseModel.BFinished}";
            sqlServerExtension_Wms.UpdateRecord("t_wh_locationProperty", content, $"where LocationCode = '{wareHouseModel.LocationCode}'");
            sqlServerExtension_Wms.Disconnect();
        }

        public void SetFullWareHouseModel(CarModel carModel, string LocationCode, int Site, int status = 1)
        {
            string content = $"status ={status},";
            if (Site == 1)
            {
                content = content + $"Attribute1 = '{carModel.TaskNo}',Attribute2 = '{carModel.FirstPileNo}',Attribute3 = {carModel.FirstRollMaterialType},Attribute4 = {carModel.FirstRollMaterialQuantity}," +
                    $"Attribute5 = {carModel.FirstRollLayer},Attribute6 = {carModel.FirstTopLayerNumber},Attribute7 = {carModel.FirstRollBFinished}";
            }
            else
            {
                content = content + $"Attribute1 = '{carModel.TaskNo}',Attribute2 = '{carModel.SecondPileNo}',Attribute3 = {carModel.SecondRollMaterialType},Attribute4 = {carModel.SecondRollMaterialQuantity}," +
                    $"Attribute5 = {carModel.SecondRollLayer},Attribute6 = {carModel.SecondTopLayerNumber},Attribute7 = {carModel.SecondRollBFinished}";
            }
            sqlServerExtension_Wms.UpdateRecord("t_wh_locationProperty", content, $"where LocationCode = '{LocationCode}'");
            sqlServerExtension_Wms.Disconnect();
        }

        public void SetEmptyWareHouseModel(string LocationCode)
        {
            string content = $"status = 2,Attribute1 = '0',Attribute2 = '0',Attribute3 = '0',Attribute4 = 0,Attribute5 = 0,Attribute6 = 0,Attribute7 = 0";
            sqlServerExtension_Wms.UpdateRecord("t_wh_locationProperty", content, $"where LocationCode = '{LocationCode}'");
            sqlServerExtension_Wms.Disconnect();
        }

        public void UpdateWareHouseStatus(string LocationCode, int Status)
        {
            sqlServerExtension_Wms.UpdateRecord("t_wh_locationProperty", $"Status = {Status}", $"where LocationCode = '{LocationCode}'");
            sqlServerExtension_Wms.Disconnect();
        }

        public int ExchangeMaterialType(int MaterialType)
        {
            if (MaterialType == 3) { return 2; }
            else if (MaterialType == 4 || MaterialType == 5) { return 3; }
            else if (MaterialType == 6) { return 4; }
            //else if (MaterialType == 5) { return 4; }
            return MaterialType;
        }
    }
}
