﻿using CasunCommon.SystemLog;
using Pms.EventLibrary.TaskEvent;
using Pms.EventLibrary.TaskEventArgs;
using Pms.InternalInterface.Models;
using Pms.UserEvent.Config;
using Pms.UserEvent.Service;
using System.Threading;

namespace Pms.UserEvent.StepBookEvent
{
    /// <summary>
    /// 机械手换夹具前参数准备，暂时不起作用，机械手自己判断换夹具
    /// </summary>
    public class Behavior_65020 : BaseStepBookEvent
    {
        public DeceiveService deceiveService { get; set; }

        public Behavior_65020() : base(65020)
        {

        }

        protected override void StepBookStarted(object sender, P_StepBookExecuteEventArgs e)
        {
            deceiveService = new DeceiveService(CConfigManager.gs_globalConfig.PMSDataBaseUrl);
        }

        protected override void StepBookEnd(object sender, P_StepBookExecuteEventArgs e)
        {
            int MaterialType = deceiveService.GetMaterialType(e.TaskBook.WareHouse) == 1 ? 1 : 2;
            CPmsControllers.Instance.CarrierController.WriteLogicValues(e.TaskBook.Carrier, 20, new int[] { MaterialType, 0, 0 }, out int failcode);
            CLog.Instance.WriteLog("VcuLogicValue", $"任务编号：{e.TaskBook.OrderID}，小车编号：{e.TaskBook.Carrier}，操作码：65020，逻辑值：{MaterialType}-0-0");
            e.IsSuccessed = true;
        }
    }
}
