﻿using CasunCommon.SystemLog;
using Pms.EventLibrary.TaskEvent;
using Pms.EventLibrary.TaskEventArgs;
using Pms.UserEvent.Config;
using Pms.UserEvent.Service;
using System;

namespace Pms.UserEvent.StepBookEvent
{
    /// <summary>
    /// 操作机械手前进行信号复位
    /// </summary>
    public class Behavior_65022 : BaseStepBookEvent
    {
        public DeceiveService deceiveService { get; set; }

        public Behavior_65022() : base(65022)
        {

        }

        protected override void StepBookStarted(object sender, P_StepBookExecuteEventArgs e)
        {
            deceiveService = new DeceiveService(CConfigManager.gs_globalConfig.PMSDataBaseUrl);
        }

        protected override void StepBookEnd(object sender, P_StepBookExecuteEventArgs e)
        {
            try
            {
                string[] strArr = e.TaskBook.WareHouse.Split('_');
                if (strArr == null || strArr.Length != 3) { e.IsSuccessed = false; return; }
                string mesName = deceiveService.ToMesName(strArr[0] + '_' + strArr[1]);
                CPmsControllers.Instance.CarrierController.WriteLogicValues(e.TaskBook.Carrier, 20, new int[] { Convert.ToInt32(mesName), Convert.ToInt32(strArr[2]), 0 }, out int failcode);
                CLog.Instance.WriteLog("VcuLogicValue", $"任务编号：{e.TaskBook.OrderID}，小车编号：{e.TaskBook.Carrier}，操作码：65022，逻辑值：{Convert.ToInt32(mesName)}-{Convert.ToInt32(strArr[2])}-0"); e.IsSuccessed = true;
            }
            catch(Exception ex)
            {
                e.IsSuccessed = false;
            }
        }
    }
}
