﻿using CasunCommon.SystemLog;
using Pms.EventLibrary.TaskEvent;
using Pms.EventLibrary.TaskEventArgs;
using Pms.InternalInterface.Enums;
using Pms.InternalInterface.Models;
using Pms.UserEvent.Config;
using Pms.UserEvent.EnumType;
using Pms.UserEvent.Model;
using Pms.UserEvent.Service;

namespace Pms.UserEvent.StepBookEvent
{
    /// <summary>
    /// 挂表第2滚筒第1层及第1滚筒最后1层跳步处理+摘表第2滚筒最后1层及第1滚筒最后1层跳步处理
    /// </summary>
    public class Behavior_65024 : BaseStepBookEvent
    {
        public TaskService taskService { get; set; }

        public CarService carService { get; set; }

        public DeceiveService deceiveService { get; set; }

        public WorkOrderService workOrderService { get; set; }

        public CacheService cacheService { get; set; }

        public Behavior_65024() : base(65024)
        {

        }

        protected override void StepBookStarted(object sender, P_StepBookExecuteEventArgs e)
        {
            //taskService = new TaskService(CConfigManager.gs_globalConfig.PMSDataBaseUrl);
            carService = new CarService(CConfigManager.gs_globalConfig.PMSDataBaseUrl);
            //deceiveService = new DeceiveService(CConfigManager.gs_globalConfig.PMSDataBaseUrl);
            //workOrderService = new WorkOrderService(CConfigManager.gs_globalConfig.PMSDataBaseUrl);
            //cacheService = new CacheService(CConfigManager.gs_globalConfig.PMSDataBaseUrl);
        }

        protected override void StepBookEnd(object sender, P_StepBookExecuteEventArgs e)
        {
            OrderData orderData = CPmsControllers.Instance.OrderDataController.GetOrder(e.TaskBook.OrderID, out string strMsg, out EFailCode failCode);
            CarModel carModel = carService.GetCar(e.TaskBook.Carrier); if (carModel == null) { e.IsSuccessed = false; return; }
            if (carModel.FirstRollLayer==1)//|| carModel.SecondRollLayer == 1
            {
                
            }
            else
            {
                e.IsDefaultNext = false;
            }
            e.IsSuccessed = true;
        }
    }
}
