﻿using CasunCommon.SystemLog;
using MaxCommunication.DataBase.SQLServer;
using Pms.EventLibrary.TaskEvent;
using Pms.EventLibrary.TaskEventArgs;
using Pms.UserEvent.Communication;
using Pms.UserEvent.Config;
using Pms.UserEvent.SystemEvent;
using System;
using System.Data;

namespace Pms.UserEvent.StepBookEvent
{
    public class Behavior_65005 : BaseStepBookEvent
    {
        public Behavior_65005() : base(65005)
        {

        }

        protected override void StepBookEnd(object sender, P_StepBookExecuteEventArgs e)
        {
            if (e.TaskBook.WareHouse.Remove(e.TaskBook.WareHouse.Length - 4, 4) == AbnormalCommunication.ExceptionName)
            {
                e.IsSuccessed = ExceptionProtocol(); return;
            }
            else if (e.TaskBook.WareHouse.Remove(e.TaskBook.WareHouse.Length - 4, 4) == WareHouseCommunication.WareHouse_In)
            {
                e.IsSuccessed = WareHouseProtocol(); return;
            }
            else
            {
                e.IsSuccessed = TransportPotocol(e.TaskBook.WareHouse); return;
            }
        }

        public bool TransportPotocol(string WareHouseID)
       {
            SQLServerExtension sqlServerExtension = new SQLServerExtension(CConfigManager.gs_globalConfig.PMSDataBaseUrl);
            DataTable dt = sqlServerExtension.QueryTable("PMS_Max_DeceiveManager", $"where FirstRoll = '{WareHouseID}' or SecondRoll = '{WareHouseID}'");
            sqlServerExtension.Disconnect();

            if (dt == null || dt.Rows.Count == 0)
            {
                CLog.Instance.WriteLog("DeceiveLog", "设备管理中未配置此输送线的地址偏移量，库位：" + WareHouseID);
                return false;
            }
            string Address = "DB10." + (Convert.ToInt32(dt.Rows[0]["Offset"]?.ToString())).ToString();
            if(!CSystemEvent.AbutmentEnable)
            {
                return true;
            }
            if (!CSystemEvent.transportCommunication.ReadBool(Address + ".2"))
            {
                return false;
            }
            if (!CSystemEvent.transportCommunication.WriteBool(Address + ".0", false))
            {
                CLog.Instance.WriteLog("TransPortAlarmLog", "中控清除请求PLC接料命令失败，PLC地址：" + Address + ".0");
                return false;
            }
            return true;
        }

        public bool ExceptionProtocol()
        {
            //if (CSystemEvent.AbutmentEnable)
            //{
            //    return true;
            //}
            if (!CSystemEvent.abnormalCommunication.ReadBool("DB1.0.2"))
            {
                return false;
            }
            if (!CSystemEvent.abnormalCommunication.WriteBool("DB1.0.0", false))
            {
                CLog.Instance.WriteLog("AbnormalAlarmLog", "中控清除请求PLC接料命令失败，PLC地址：DB1.0.0");
                return false;
            }
            return true;
        }

        public bool WareHouseProtocol()
        {
            if (!CSystemEvent.wareHouseCommunication.ReadBool("DB1304.2.1"))//DB1.0.2
            {
                return false;
            }
            if (!CSystemEvent.wareHouseCommunication.WriteBool("DB1304.0.0", false))//DB1.0.0
            {
                CLog.Instance.WriteLog("WareHouseAlarmLog", "中控清除请求PLC接料命令失败，PLC地址：DB1304.0.0");
                return false;
            }
            return true;
        }
    }
}
