﻿using Pms.EventLibrary.TaskEvent;
using Pms.EventLibrary.TaskEventArgs;
using Pms.InternalInterface.Enums;
using Pms.InternalInterface.Models;
using Pms.UserEvent.Config;
using Pms.UserEvent.Model;
using Pms.UserEvent.Service;
using Pms.UserEvent.SystemEvent;
using System;

namespace Pms.UserEvent.StepBookEvent
{
    public class Behavior_65006 : BaseStepBookEvent
    {
        public CarService carService { get; set; }

        public WareHouseService wareHouseService { get; set; }

        public TrayBarcodeService trayBarcodeService { get; set; }

        public Behavior_65006() : base(65006)
        {

        }

        protected override void StepBookStarted(object sender, P_StepBookExecuteEventArgs e)
        {
            carService = new CarService(CConfigManager.gs_globalConfig.PMSDataBaseUrl);
            wareHouseService = new WareHouseService(CConfigManager.gs_globalConfig.WMSDataBaseUrl);
            trayBarcodeService = new TrayBarcodeService(CConfigManager.gs_globalConfig.PMSDataBaseUrl);
        }

        protected override void StepBookEnd(object sender, P_StepBookExecuteEventArgs e)
        {
            OrderData orderData = CPmsControllers.Instance.OrderDataController.GetOrder(e.StepBook.OrderID, out string strMsg, out EFailCode failCode);
            int Site = CalculatorRollSite(Convert.ToInt32(orderData.OtherOrderData), orderData.PosArr, e.TaskBook.WareHouse);
            CarModel carModel = carService.GetCar(e.TaskBook.Carrier); 
            if (e.TaskBook.WareHouse.Contains("Storehouse_Enter"))
            {
                //应增加回库删除托盘信息（已添加）
                string TrayBarcode = orderData.OtherOrderData == CSystemEvent.FirstRollerPosition ? carModel.FirstPileNo : carModel.SecondPileNo;
                if (TrayBarcode == null || TrayBarcode.Length == 0)
                {
                    e.IsSuccessed = true; return;
                }
                string TrayBarcodeArr = TrayBarcode.Split('_').Length == 0 ? $"'{TrayBarcode}'" : $"'{TrayBarcode.Split('_')[0]}'";
                foreach (var item in TrayBarcode.Split('_'))
                {
                    TrayBarcodeArr = TrayBarcodeArr + $",'{item}'";
                }
                trayBarcodeService.DeleteTrayBarcode(TrayBarcodeArr);
            }
            else if (e.TaskBook.WareHouse.Contains("WareHouse") /*&& !e.TaskBook.WareHouse.Contains("WareHouse_7")*/)//取消:2022-5-9新增:送到数据上传点不更新库位状态
            {
                int Status = e.TaskBook.WareHouse.Contains("WareHouse_7") ? 3 : 1;
                if (e.TaskBook.WareHouse.Contains("WareHouse_7"))
                {
                    Status = 3;
                }
                wareHouseService.SetFullWareHouseModel(carModel, e.TaskBook.WareHouse.Remove(e.TaskBook.WareHouse.Length - 4, 4), Site, Status);
            }
            string warehouse = e.TaskBook.WareHouse.Remove(e.TaskBook.WareHouse.Length - 4, 4);
            if (CSystemEvent.DictWareHouseAbutmentInfo.ContainsKey(warehouse))
            {
                CSystemEvent.DictWareHouseAbutmentInfo[warehouse].Carrier = 0;
                CSystemEvent.DictWareHouseAbutmentInfo[warehouse].SignalClean = true;
            }
            carService.UpdateEmptyCarRoll(carModel.CarID, Site);//最后再清滚筒数据
            e.IsSuccessed = true;
        }

        public int CalculatorRollSite(int Site, string[] PosArr, string Pos)
        {
            if (Site != 3) { return Site; }
            for (int i = 0; i < PosArr.Length; i++)
            {
                if (Pos == PosArr[i]) { return i + 1; }
            }
            return 0;
        }
    }
}
