﻿using Pms.EventLibrary.TaskEvent;
using Pms.EventLibrary.TaskEventArgs;
using Pms.InternalInterface.Enums;
using Pms.InternalInterface.Models;
using Pms.UserEvent.Config;
using Pms.UserEvent.Model;
using Pms.UserEvent.Service;
using Pms.UserEvent.SystemEvent;
using Pms.UserEvent.Communication;
using System;
using System.Collections.Generic;

namespace Pms.UserEvent.StepBookEvent
{
    public class Behavior_65007 : BaseStepBookEvent
    {
        public MesService mesService { get; set; }

        public CarService carService { get; set; }

        public DeceiveService deceiveService { get; set; }

        public TrayBarcodeService trayBarcodeService { get; set; }

        public Behavior_65007() : base(65007)
        {

        }

        protected override void StepBookStarted(object sender, P_StepBookExecuteEventArgs e)
        {
            mesService = new MesService(CConfigManager.gs_globalConfig.PMSDataBaseUrl);
            carService = new CarService(CConfigManager.gs_globalConfig.PMSDataBaseUrl);
            deceiveService = new DeceiveService(CConfigManager.gs_globalConfig.PMSDataBaseUrl);
            trayBarcodeService = new TrayBarcodeService(CConfigManager.gs_globalConfig.PMSDataBaseUrl);
        }

        protected override void StepBookEnd(object sender, P_StepBookExecuteEventArgs e)
        {
            string warehouse = e.TaskBook.WareHouse.Remove(e.TaskBook.WareHouse.Length - 4, 4);
            if (CSystemEvent.DictWareHouseAbutmentInfo.ContainsKey(warehouse))
            {
                CSystemEvent.DictWareHouseAbutmentInfo[warehouse].Carrier = 0;
                CSystemEvent.DictWareHouseAbutmentInfo[warehouse].SignalClean = true;
            }
            OrderData orderData = CPmsControllers.Instance.OrderDataController.GetOrder(e.TaskBook.OrderID, out string strMsg, out EFailCode failCode);
            CarModel carModel = carService.GetCar(e.TaskBook.Carrier);

            if (e.TaskBook.WareHouse.Contains("WareHouse_100"))
            {
                return;
            }
            //else if (e.TaskBook.WareHouse.Contains("WareHouse_") && !e.TaskBook.WareHouse.Contains("WareHouse_7"))//20220607 注释
            //{
            //    return;
            //}

           
            if (carModel != null && e.TaskBook.WareHouse.Remove(e.TaskBook.WareHouse.Length - 4, 4) == WareHouseCommunication.WareHouse_Out)//e.TaskBook.WareHouse == WareHouseCommunication.WareHouse_Out
            {
                string PileNo = CalculatorRollSite(Convert.ToInt32(orderData.OtherOrderData), orderData.PosArr, e.TaskBook.WareHouse) == 1 ? carModel.FirstPileNo : carModel.SecondPileNo;
                mesService.PickUpFinished(PileNo, deceiveService.ToMesName(orderData.PosArr != null && orderData.PosArr.Length > 1 ? orderData.PosArr[1] : e.TaskBook.WareHouse));//修改1取货完成上报送达台体e.TaskBook.WareHouse
            }
            else if (e.TaskBook.WareHouse.Contains("WareHouse_")&&carModel != null && orderData.PosArr != null && orderData.PosArr.Length > 1 && (orderData.PosArr[1].Contains("WareHouse_7") || orderData.PosArr[1].Contains("CT_Enter")) && carModel.FirstRollLayer <= 6)//从缓存台搬往雕刻台、WareHouse_7调用组垛完成
            {
                string PileNo = CalculatorRollSite(Convert.ToInt32(orderData.OtherOrderData), orderData.PosArr, e.TaskBook.WareHouse) == 1 ? carModel.FirstPileNo : carModel.SecondPileNo;
                ExcerptWatchFinishModel excerptWatchFinishModel = new ExcerptWatchFinishModel(PileNo, orderData.Reserved2);
                List<TrayBarcodeModel> TrayBarcodeList =carModel.FirstRollMaterialQuantity>=1? trayBarcodeService.GetAllTrayBarcode(PileNo): trayBarcodeService.GetAllTrayBarcodeRemain(PileNo);
                foreach (var item in TrayBarcodeList)
                {
                    TrayRelationshipModel trayRelationshipModel = new TrayRelationshipModel(item.TrayBarcode);
                    if (carModel.FirstRollMaterialType == 1)
                    {
                        if (item.Barcode1 != "0") { trayRelationshipModel.METER.Add(new RelationshipModel("1", item.Barcode1)); }
                        if (item.Barcode2 != "0") { trayRelationshipModel.METER.Add(new RelationshipModel("2", item.Barcode2)); }
                        if (item.Barcode3 != "0") { trayRelationshipModel.METER.Add(new RelationshipModel("3", item.Barcode3)); }
                        if (item.Barcode4 != "0") { trayRelationshipModel.METER.Add(new RelationshipModel("4", item.Barcode4)); }
                        if (item.Barcode5 != "0") { trayRelationshipModel.METER.Add(new RelationshipModel("5", item.Barcode5)); }
                        if (item.Barcode6 != "0") { trayRelationshipModel.METER.Add(new RelationshipModel("6", item.Barcode6)); }
                        if (item.Barcode7 != "0") { trayRelationshipModel.METER.Add(new RelationshipModel("7", item.Barcode7)); }
                        if (item.Barcode8 != "0") { trayRelationshipModel.METER.Add(new RelationshipModel("8", item.Barcode8)); }
                        if (item.Barcode9 != "0") { trayRelationshipModel.METER.Add(new RelationshipModel("9", item.Barcode9)); }
                        if (item.Barcode10 != "0") { trayRelationshipModel.METER.Add(new RelationshipModel("10", item.Barcode10)); }
                        if (item.Barcode11 != "0") { trayRelationshipModel.METER.Add(new RelationshipModel("11", item.Barcode11)); }
                        if (item.Barcode12 != "0") { trayRelationshipModel.METER.Add(new RelationshipModel("12", item.Barcode12)); }
                    }
                    else
                    {
                        if (item.Barcode1 != "0") { trayRelationshipModel.METER.Add(new RelationshipModel("1", item.Barcode1)); }
                        if (item.Barcode2 != "0") { trayRelationshipModel.METER.Add(new RelationshipModel("2", item.Barcode2)); }
                        if (item.Barcode3 != "0") { trayRelationshipModel.METER.Add(new RelationshipModel("3", item.Barcode3)); }
                        if (item.Barcode4 != "0") { trayRelationshipModel.METER.Add(new RelationshipModel("4", item.Barcode4)); }
                    }
                    excerptWatchFinishModel.BOX.Add(trayRelationshipModel);
                }
                mesService.ReportExcerptWatchFinish(excerptWatchFinishModel);
            }
        }

        public int CalculatorRollSite(int Site, string[] PosArr, string Pos)
        {
            if (Site != 3) { return Site; }
            for (int i = 0; i < PosArr.Length; i++)
            {
                if (Pos == PosArr[i]) { return i + 1; }
            }
            return 0;
        }
    }
}
