﻿using CasunCommon.SystemLog;
using Pms.EventLibrary.TaskEvent;
using Pms.EventLibrary.TaskEventArgs;
using Pms.InternalInterface.Enums;
using Pms.InternalInterface.Models;
using Pms.UserEvent.Config;
using Pms.UserEvent.Model;
using Pms.UserEvent.Service;
using Pms.UserEvent.SystemEvent;
using System;

namespace Pms.UserEvent.StepBookEvent
{
    public class Behavior_65008 : BaseStepBookEvent
    {
        public MesService mesService { get; set; }

        public CarService carService { get; set; }

        public DeceiveService deceiveService { get; set; }

        public Behavior_65008() : base(65008)
        {

        }

        protected override void StepBookStarted(object sender, P_StepBookExecuteEventArgs e)
        {
            mesService = new MesService(CConfigManager.gs_globalConfig.PMSDataBaseUrl);
            carService = new CarService(CConfigManager.gs_globalConfig.PMSDataBaseUrl);
            deceiveService = new DeceiveService(CConfigManager.gs_globalConfig.PMSDataBaseUrl);
        }

        protected override void StepBookEnd(object sender, P_StepBookExecuteEventArgs e)
        {
            if (!CSystemEvent.AbutmentEnable)
            {
                return;
            }
            if (e.TaskBook.WareHouse.Contains("WareHouse_100") )
            {
                return;
            }
            else if (e.TaskBook.WareHouse.Contains("WareHouse_") && !e.TaskBook.WareHouse.Contains("WareHouse_7"))
            {
                return;
            }
            OrderData orderData = CPmsControllers.Instance.OrderDataController.GetOrder(e.TaskBook.OrderID, out string strMsg, out EFailCode failCode);
            CarModel carModel = carService.GetCar(e.TaskBook.Carrier);
            if (carModel != null)
            {
                string PileNo = CalculatorRollSite(Convert.ToInt32(orderData.OtherOrderData), orderData.PosArr, e.TaskBook.WareHouse) == 1 ? carModel.FirstPileNo : carModel.SecondPileNo;
                CLog.Instance.WriteLog("InterfaceRequest_5_4", "垛号:"+ PileNo+",库位："+ e.TaskBook.WareHouse);
                mesService.DeliveryFinished(PileNo, deceiveService.ToMesName(e.TaskBook.WareHouse));//修改4送货到达接口Mes相关库位才调
            }
        }

        public int CalculatorRollSite(int Site, string[] PosArr, string Pos)
        {
            if (Site != 3) { return Site; }
            for (int i = 0; i < PosArr.Length; i++)
            {
                if (Pos == PosArr[i]) { return i + 1; }
            }
            return 0;
        }
    }
}
