﻿using Pms.EventLibrary.TaskEvent;
using Pms.EventLibrary.TaskEventArgs;
using Pms.InternalInterface.Enums;
using Pms.InternalInterface.Models;
using Pms.UserEvent.Config;
using Pms.UserEvent.Model;
using Pms.UserEvent.Service;
using Pms.UserEvent.SystemEvent;
using System.Collections.Generic;

namespace Pms.UserEvent.StepBookEvent
{
    /// <summary>
    /// 抓表完成上报
    /// </summary>
    public class Behavior_65054 : BaseStepBookEvent
    {
        public CarService carService { get; set; }

        public MesService mesService { get; set; }

        public TrayBarcodeService trayBarcodeService { get; set; }

        public CacheService cacheService { get; set; }

        public DeceiveService deceiveService { get; set; }

        public Behavior_65054() : base(65054)
        {

        }

        protected override void StepBookStarted(object sender, P_StepBookExecuteEventArgs e)
        {
            carService = new CarService(CConfigManager.gs_globalConfig.PMSDataBaseUrl);
            mesService = new MesService(CConfigManager.gs_globalConfig.PMSDataBaseUrl);
            trayBarcodeService = new TrayBarcodeService(CConfigManager.gs_globalConfig.PMSDataBaseUrl);
            cacheService = new CacheService(CConfigManager.gs_globalConfig.PMSDataBaseUrl);
            deceiveService = new DeceiveService(CConfigManager.gs_globalConfig.PMSDataBaseUrl);
        }

        protected override void StepBookEnd(object sender, P_StepBookExecuteEventArgs e)
        {
            OrderData orderData = CPmsControllers.Instance.OrderDataController.GetOrder(e.TaskBook.OrderID, out string strMsg, out EFailCode failCode);
            CarModel carModel = carService.GetCar(e.TaskBook.Carrier); if (carModel == null) { e.IsSuccessed = false; return; }
            if (carModel.FirstRollLayer == 6 && carModel.FirstTopLayerNumber == 12)
            {
                ExcerptWatchFinishModel excerptWatchFinishModel = new ExcerptWatchFinishModel(carModel.FirstPileNo, orderData.Reserved2);
                List<TrayBarcodeModel> TrayBarcodeList = trayBarcodeService.GetAllTrayBarcode(carModel.FirstPileNo);
                foreach (var item in TrayBarcodeList)
                {
                    TrayRelationshipModel trayRelationshipModel = new TrayRelationshipModel(item.TrayBarcode);
                    if (item.Barcode1 != "0") { trayRelationshipModel.METER.Add(new RelationshipModel("1", item.Barcode1)); }
                    if (item.Barcode2 != "0") { trayRelationshipModel.METER.Add(new RelationshipModel("2", item.Barcode2)); }
                    if (item.Barcode3 != "0") { trayRelationshipModel.METER.Add(new RelationshipModel("3", item.Barcode3)); }
                    if (item.Barcode4 != "0") { trayRelationshipModel.METER.Add(new RelationshipModel("4", item.Barcode4)); }
                    if (item.Barcode5 != "0") { trayRelationshipModel.METER.Add(new RelationshipModel("5", item.Barcode5)); }
                    if (item.Barcode6 != "0") { trayRelationshipModel.METER.Add(new RelationshipModel("6", item.Barcode6)); }
                    if (item.Barcode7 != "0") { trayRelationshipModel.METER.Add(new RelationshipModel("7", item.Barcode7)); }
                    if (item.Barcode8 != "0") { trayRelationshipModel.METER.Add(new RelationshipModel("8", item.Barcode8)); }
                    if (item.Barcode9 != "0") { trayRelationshipModel.METER.Add(new RelationshipModel("9", item.Barcode9)); }
                    if (item.Barcode10 != "0") { trayRelationshipModel.METER.Add(new RelationshipModel("10", item.Barcode10)); }
                    if (item.Barcode11 != "0") { trayRelationshipModel.METER.Add(new RelationshipModel("11", item.Barcode11)); }
                    if (item.Barcode12 != "0") { trayRelationshipModel.METER.Add(new RelationshipModel("12", item.Barcode12)); }
                    excerptWatchFinishModel.BOX.Add(trayRelationshipModel);
                }
                if (!CSystemEvent.AbutmentEnable)
                {
                    return;
                }
                mesService.ReportExcerptWatchFinish(excerptWatchFinishModel);
            }
            else if (cacheService.SearchRemainStore(e.TaskBook.Carrier, orderData.Reserved2, 1, out int RowIndex, out string[] Barcode))//20220607 add
            {
                if (!deceiveService.HasExcerptWatchOK(e.TaskBook.WareHouse, orderData.Reserved2))
                {
                    e.IsDefaultNext = false;
                }
            }

            //else if (Convert.ToInt32(orderData.Reserved3) == 1 && !deceiveService.CanSingleExcerptWatchOK(e.TaskBook.WareHouse, orderData.Reserved2, out string[] BarcodeOK, out int RowIndexOK, out int ColumnIndexOK, out int ExcerptCountOK)
            //        && cacheService.SearchRemainStore(e.TaskBook.Carrier, orderData.Reserved2, Convert.ToInt32(orderData.Reserved3), out int RowIndexx, out string[] Barcodee))
            //{

            //}
            //else if (Convert.ToInt32(orderData.Reserved3) == 2 && !deceiveService.CanSingleExcerptWatchNG(e.TaskBook.WareHouse, orderData.Reserved2, out string[] BarcodeNG, out int RowIndexNG, out int ColumnIndexNG, out int ExcerptCountNG)
            //    && cacheService.SearchRemainStore(e.TaskBook.Carrier, orderData.Reserved2, Convert.ToInt32(orderData.Reserved3), out int RowIndexxx, out string[] Barcodeee))
            //{

            //}
        }
    }
}
