﻿using CasunCommon.SystemLog;
using Pms.EventLibrary.TaskEvent;
using Pms.EventLibrary.TaskEventArgs;
using Pms.InternalInterface.Enums;
using Pms.InternalInterface.Models;
using Pms.UserEvent.Config;
using Pms.UserEvent.EnumType;
using Pms.UserEvent.Model;
using Pms.UserEvent.Service;
using System;
using System.Threading;

namespace Pms.UserEvent.StepBookEvent
{
    /// <summary>
    /// 机械手第二次放缓存台所抓个数是否3个判断,可能跳步
    /// </summary>
    public class Behavior_65078 : BaseStepBookEvent
    {
        public TaskService taskService { get; set; }

        public CarService carService { get; set; }

        public DeceiveService deceiveService { get; set; }

        public WorkOrderService workOrderService { get; set; }

        public CacheService cacheService { get; set; }

        public Behavior_65078() : base(65078)
        {

        }

        protected override void StepBookStarted(object sender, P_StepBookExecuteEventArgs e)
        {
            taskService = new TaskService(CConfigManager.gs_globalConfig.PMSDataBaseUrl);
            carService = new CarService(CConfigManager.gs_globalConfig.PMSDataBaseUrl);
            deceiveService = new DeceiveService(CConfigManager.gs_globalConfig.PMSDataBaseUrl);
            workOrderService = new WorkOrderService(CConfigManager.gs_globalConfig.PMSDataBaseUrl);
            cacheService = new CacheService(CConfigManager.gs_globalConfig.PMSDataBaseUrl);
        }

        protected override void StepBookEnd(object sender, P_StepBookExecuteEventArgs e)
        {
            OrderData orderData = CPmsControllers.Instance.OrderDataController.GetOrder(e.TaskBook.OrderID, out string strMsg, out EFailCode failCode);
            CarModel carModel = carService.GetCar(e.TaskBook.Carrier); if (carModel == null) { e.IsSuccessed = false; return; }
            if (!taskService.JudgementEWTaskStatus(e.TaskBook.Reserved1, new ExcerptWatchEnum[] { ExcerptWatchEnum.TaskPointFinished, ExcerptWatchEnum.TaskFinished })
                && cacheService.JudgementJawsSite(e.TaskBook.Carrier, carModel.PullNumber, orderData.Reserved2, Convert.ToInt32(orderData.Reserved3), new string[] { carModel.Barcode1, carModel.Barcode2, carModel.Barcode3 }, out int RowIndex, out int ColumnIndex, out int StartSite))
            {
                CPmsControllers.Instance.CarrierController.WriteLogicValues(e.TaskBook.Carrier, 20, new int[] { RowIndex, ColumnIndex, StartSite }, out int failcode1);
                CLog.Instance.WriteLog("VcuLogicValue", $"任务编号：{e.TaskBook.OrderID}，小车编号：{e.TaskBook.Carrier}，操作码：65078，逻辑值：{RowIndex}-{ColumnIndex}-{StartSite}");

                carModel.PullNumber = carModel.PullNumber - ColumnIndex;
                switch (ColumnIndex)
                {
                    case 0x01: carModel.Barcode1 = "0"; break;
                    case 0x02: carModel.Barcode2 = "0"; break;
                    case 0x04: carModel.Barcode3 = "0"; break;
                }
                carService.UpdateFullCarRoll(carModel);
                Thread.Sleep(1000);
            }
            else
            {
                e.IsDefaultNext = false;
            }
            e.IsSuccessed = true;
        }
    }
}
