﻿using Pms.EventLibrary.TaskEvent;
using Pms.EventLibrary.TaskEventArgs;
using Pms.InternalInterface.Enums;
using Pms.InternalInterface.Models;
using Pms.UserEvent.Config;
using Pms.UserEvent.EnumType;
using Pms.UserEvent.Model;
using Pms.UserEvent.Service;
using Pms.UserEvent.SystemEvent;
using System;
using System.Collections.Generic;

namespace Pms.UserEvent.StepBookEvent
{
    /// <summary>
    /// 上报挂表完成
    /// </summary>
    public class Behavior_65034 : BaseStepBookEvent
    {
        public DeceiveService deceiveService { get; set; }

        public MesService mesService { get; set; }

        public TaskService taskService { get; set; }

        public Behavior_65034() : base(65034)
        {

        }

        protected override void StepBookStarted(object sender, P_StepBookExecuteEventArgs e)
        {
            taskService = new TaskService(CConfigManager.gs_globalConfig.PMSDataBaseUrl);
            deceiveService = new DeceiveService(CConfigManager.gs_globalConfig.PMSDataBaseUrl);
            mesService = new MesService(CConfigManager.gs_globalConfig.PMSDataBaseUrl);
        }

        protected override void StepBookEnd(object sender, P_StepBookExecuteEventArgs e)
        {
            PocketWatchFinishModel pocketWatchFinishModel = new PocketWatchFinishModel(deceiveService.ToMesName(e.TaskBook.WareHouse.Remove(e.TaskBook.WareHouse.Length - 2, 2)));
            List<DeceiveModel> DeceiveList = deceiveService.GetDeceiveModel(e.TaskBook.WareHouse);
            if (DeceiveList == null || DeceiveList.Count == 0) { e.IsSuccessed = false; return; }
            List<DeceiveModel> DeceiveEmptyList = DeceiveList.FindAll(t => t.Status == 2);
            if (DeceiveEmptyList != null && DeceiveEmptyList.Count != 0)
            {
                foreach (var item in DeceiveEmptyList)
                {
                    switch (item.ColumnIndex % 3)
                    {
                        case 0:
                            var deviceModel1 = DeceiveList.FindAll(t => t.RowIndex == item.RowIndex && t.ColumnIndex > item.ColumnIndex - 3 && t.ColumnIndex < item.ColumnIndex && t.Status == 2);
                            if (deviceModel1.Count == 2) { e.IsSuccessed = true; return; }
                            break;
                        case 1:
                            var deviceModel2 = DeceiveList.FindAll(t => t.RowIndex == item.RowIndex && t.ColumnIndex > item.ColumnIndex && t.ColumnIndex < item.ColumnIndex + 3 && t.Status == 2);
                            if (deviceModel2.Count == 2) { e.IsSuccessed = true; return; }
                            break;
                        case 2:
                            var deviceModel3 = DeceiveList.FindAll(t => t.RowIndex == item.RowIndex && t.ColumnIndex > item.ColumnIndex - 2 && t.ColumnIndex < item.ColumnIndex + 2 && t.Status == 2);
                            if (deviceModel3.Count == 2) { e.IsSuccessed = true; return; }
                            break;
                    }
                }
            }
            OrderData orderData = CPmsControllers.Instance.OrderDataController.GetOrder(e.TaskBook.OrderID, out string strMsg, out EFailCode failCode);
            MesPWTaskModel mesTaskModel = taskService.GetPWMesTask(orderData.Reserved1);
            if ((PocketWatchEnum)Convert.ToInt32(mesTaskModel.TaskStatus)== PocketWatchEnum.TaskFinished|| (PocketWatchEnum)Convert.ToInt32(mesTaskModel.TaskStatus) == PocketWatchEnum.WorkOrderFinished)
            {
                e.IsSuccessed = true; return;
            }
            foreach (var item in DeceiveList)
            {
                pocketWatchFinishModel.METER.Add(new RelationshipModel(item.EpitopeNumber, item.Barcode));
            }
            if (!CSystemEvent.AbutmentEnable)
            {
                return;
            }
            mesService.ReportPocketWatchFinish(pocketWatchFinishModel);
        }
    }
}
