﻿using CasunCommon.SystemLog;
using Pms.EventLibrary.TaskEvent;
using Pms.EventLibrary.TaskEventArgs;
using Pms.InternalInterface.Enums;
using Pms.InternalInterface.Models;
using Pms.UserEvent.Config;
using Pms.UserEvent.EnumType;
using Pms.UserEvent.Model;
using Pms.UserEvent.Service;

namespace Pms.UserEvent.StepBookEvent
{
    /// <summary>
    /// 机械手抓空托盘前参数准备，可能跳步
    /// </summary>
    public class Behavior_65090 : BaseStepBookEvent
    {
        public TaskService taskService { get; set; }

        public CarService carService { get; set; }

        public DeceiveService deceiveService { get; set; }

        public Behavior_65090() : base(65090)
        {

        }

        protected override void StepBookStarted(object sender, P_StepBookExecuteEventArgs e)
        {
            taskService = new TaskService(CConfigManager.gs_globalConfig.PMSDataBaseUrl);
            carService = new CarService(CConfigManager.gs_globalConfig.PMSDataBaseUrl);
            deceiveService = new DeceiveService(CConfigManager.gs_globalConfig.PMSDataBaseUrl);
        }

        protected override void StepBookEnd(object sender, P_StepBookExecuteEventArgs e)
        {
            OrderData orderData = CPmsControllers.Instance.OrderDataController.GetOrder(e.TaskBook.OrderID, out string strMsg, out EFailCode failCode);
            if (!taskService.JudgementEWTaskStatus(e.TaskBook.Reserved1, new ExcerptWatchEnum[] { ExcerptWatchEnum.TaskFinished, ExcerptWatchEnum.TaskFinished }))
            {
                CarModel carModel = carService.GetCar(e.TaskBook.Carrier); if (carModel == null) { e.IsSuccessed = false; return; }
                if ((carModel.FirstTopLayerNumber == 4 || (carModel.FirstRollLayer == 0 && carModel.FirstTopLayerNumber == 0)) && carModel.SecondRollLayer != 0
                    && deceiveService.CanThreeExcerptWatchNG(e.TaskBook.WareHouse, orderData.Reserved2, out string Barcode, out int RowIndex, out int ColumnIndex))
                {
                    CPmsControllers.Instance.CarrierController.WriteLogicValues(e.TaskBook.Carrier, 20, new int[] { carModel.SecondRollLayer, 2, carModel.FirstRollLayer + 1 }, out int failcode1);
                    CLog.Instance.WriteLog("VcuLogicValue", $"任务编号：{e.TaskBook.OrderID}，小车编号：{e.TaskBook.Carrier}，操作码：65090，逻辑值：{carModel.SecondRollLayer}-2-{carModel.FirstRollLayer + 1}");

                    carModel.SecondRollLayer = carModel.SecondRollLayer - 1;
                    carModel.FirstRollLayer = carModel.FirstRollLayer + 1; carModel.FirstTopLayerNumber = 0;
                    carService.UpdateFullCarRoll(carModel);
                }
                else
                {
                    e.IsDefaultNext = false;
                }
            }
            else
            {
                CPmsControllers.Instance.CarrierController.WriteLogicValues(e.TaskBook.Carrier, 20, new int[] { 0, 0, 0 }, out int failcode1);
                CLog.Instance.WriteLog("VcuLogicValue", $"任务编号：{e.TaskBook.OrderID}，小车编号：{e.TaskBook.Carrier}，操作码：65090，逻辑值：0-0-0");
            }
            e.IsSuccessed = true;
        }
    }
}
