﻿using Pms.EventLibrary.TaskEvent;
using Pms.EventLibrary.TaskEventArgs;
using Pms.InternalInterface.Enums;
using Pms.InternalInterface.Models;
using Pms.UserEvent.Config;
using Pms.UserEvent.Model;
using Pms.UserEvent.Service;
using System.Collections.Generic;

namespace Pms.UserEvent.StepBookEvent
{
    /// <summary>
    /// 抓表完成上报
    /// </summary>
    public class Behavior_65084 : BaseStepBookEvent
    {
        public CarService carService { get; set; }

        public MesService mesService { get; set; }

        public TrayBarcodeService trayBarcodeService { get; set; }

        public WorkOrderService workOrderService { get; set; }

        public Behavior_65084() : base(65084)
        {

        }

        protected override void StepBookStarted(object sender, P_StepBookExecuteEventArgs e)
        {
            carService = new CarService(CConfigManager.gs_globalConfig.PMSDataBaseUrl);
            mesService = new MesService(CConfigManager.gs_globalConfig.PMSDataBaseUrl);
            trayBarcodeService = new TrayBarcodeService(CConfigManager.gs_globalConfig.PMSDataBaseUrl);
            workOrderService = new WorkOrderService(CConfigManager.gs_globalConfig.PMSDataBaseUrl);
        }

        protected override void StepBookEnd(object sender, P_StepBookExecuteEventArgs e)
        {
            OrderData orderData = CPmsControllers.Instance.OrderDataController.GetOrder(e.TaskBook.OrderID, out string strMsg, out EFailCode failCode);
            CarModel carModel = carService.GetCar(e.TaskBook.Carrier); if (carModel == null) { e.IsSuccessed = false; return; }
            if ((carModel.FirstRollLayer == 6 && carModel.FirstTopLayerNumber == 4) )//|| workOrderService.JudegementPocketWatchBFinshed(carModel.TaskNo)
            {
                ExcerptWatchFinishModel excerptWatchFinishModel = new ExcerptWatchFinishModel(carModel.FirstPileNo, orderData.Reserved2);
                List<TrayBarcodeModel> TrayBarcodeList = trayBarcodeService.GetAllTrayBarcode(carModel.FirstPileNo);
                foreach (var item in TrayBarcodeList)
                {
                    TrayRelationshipModel trayRelationshipModel = new TrayRelationshipModel(item.TrayBarcode);
                    if (item.Barcode1 != "0") { trayRelationshipModel.METER.Add(new RelationshipModel("1", item.Barcode1)); }
                    if (item.Barcode2 != "0") { trayRelationshipModel.METER.Add(new RelationshipModel("2", item.Barcode2)); }
                    if (item.Barcode3 != "0") { trayRelationshipModel.METER.Add(new RelationshipModel("3", item.Barcode3)); }
                    if (item.Barcode4 != "0") { trayRelationshipModel.METER.Add(new RelationshipModel("4", item.Barcode4)); }
                    excerptWatchFinishModel.BOX.Add(trayRelationshipModel);
                }
                mesService.ReportExcerptWatchFinish(excerptWatchFinishModel);
            }
        }
    }
}
