﻿using Pms.EventLibrary.TaskEvent;
using Pms.EventLibrary.TaskEventArgs;
using Pms.InternalInterface.Enums;
using Pms.InternalInterface.Models;
using Pms.UserEvent.Config;
using Pms.UserEvent.EnumType;
using Pms.UserEvent.Model;
using Pms.UserEvent.Service;
using Pms.UserEvent.SystemEvent;
using System;
using System.Collections.Generic;

namespace Pms.UserEvent.StepBookEvent
{
    /// <summary>
    /// 上报挂表完成
    /// </summary>
    public class Behavior_65044 : BaseStepBookEvent
    {
        public DeceiveService deceiveService { get; set; }

        public MesService mesService { get; set; }

        public TaskService taskService { get; set; }

        public Behavior_65044() : base(65044)
        {

        }

        protected override void StepBookStarted(object sender, P_StepBookExecuteEventArgs e)
        {
            deceiveService = new DeceiveService(CConfigManager.gs_globalConfig.PMSDataBaseUrl);
            mesService = new MesService(CConfigManager.gs_globalConfig.PMSDataBaseUrl);
            taskService = new TaskService(CConfigManager.gs_globalConfig.PMSDataBaseUrl);
        }

        protected override void StepBookEnd(object sender, P_StepBookExecuteEventArgs e)
        {
            PocketWatchFinishModel pocketWatchFinishModel = new PocketWatchFinishModel(deceiveService.ToMesName(e.TaskBook.WareHouse.Remove(e.TaskBook.WareHouse.Length - 2, 2)));
            List<DeceiveModel> DeceiveList = deceiveService.GetDeceiveModel(e.TaskBook.WareHouse);
            if (DeceiveList == null || DeceiveList.Count == 0) { e.IsSuccessed = false; return; }
            List<DeceiveModel> DeceiveEmptyList = DeceiveList.FindAll(t => t.Status == 2);
            if (DeceiveEmptyList != null && DeceiveEmptyList.Count != 0) { e.IsSuccessed = true; return; }
            OrderData orderData = CPmsControllers.Instance.OrderDataController.GetOrder(e.TaskBook.OrderID, out string strMsg, out EFailCode failCode);
            MesPWTaskModel mesTaskModel = taskService.GetPWMesTask(orderData.Reserved1);
            if ((PocketWatchEnum)Convert.ToInt32(mesTaskModel.TaskStatus) == PocketWatchEnum.TaskFinished || (PocketWatchEnum)Convert.ToInt32(mesTaskModel.TaskStatus) == PocketWatchEnum.WorkOrderFinished)
            {
                e.IsSuccessed = true; return;
            }
            foreach (var item in DeceiveList)
            {
                pocketWatchFinishModel.METER.Add(new RelationshipModel(item.EpitopeNumber, item.Barcode));
            }
            if (!CSystemEvent.AbutmentEnable)
            {
                return;
            }
            mesService.ReportPocketWatchFinish(pocketWatchFinishModel);
        }
    }
}
