﻿using CasunCommon.SystemLog;
using Pms.Common.SystemEnum;
using Pms.InternalInterface.Enums;
using Pms.InternalInterface.Models;
using Pms.UserEvent.SystemEvent;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace Pms.UserEvent
{
    public partial class frmTest : Form
    {
        private static volatile frmTest _MainForm = null;
        //private static volatile MultiThread_Singleton instance = null;
        private static object lockHelper = new object();

        public static frmTest ShowForm()
        {
            lock (lockHelper)
            {
                if (_MainForm == null)
                {
                    _MainForm = new frmTest();
                    //_MainForm.MdiParent = _MainForm;
                    _MainForm.FormClosed += _MainForm_FormClosed;
                    _MainForm.WindowState = FormWindowState.Maximized;
                    _MainForm.Show();
                }
                else
                {
                    _MainForm.Activate();
                }
            }
            return _MainForm;
        }

        private static void _MainForm_FormClosed(object sender, FormClosedEventArgs e)
        {
            _MainForm = null;
        }

        private frmTest()
        {
            InitializeComponent();
            //MakeCards();
            //Registers();
            //BtnCall_Click(null, null);
            Task.Factory.StartNew(ScanAbutmentSwitch);
            btnAbutmentEnable.Click += BtnAbutmentEnable_Click;
            btnFirstRoller.Click += BtnFirstRoller_Click;
            btnSecondRoller.Click += BtnSecondRoller_Click;
        }

        private void BtnSecondRoller_Click(object sender, EventArgs e)
        {
            string strUp = txtUp.Text;
            string strDown = txtDown.Text;
            if (string.IsNullOrEmpty(strDown) || string.IsNullOrEmpty(strUp))
            {
                MessageBox.Show("输入项均不能为空");
                return;
            }
            strUp = strUp + "_2nd";
            strDown = strDown + "_2nd";
            string orderid = "T2_" + DateTime.Now.ToString("yyyyMMddhhmmssff");
            COrderInfo orderInfo = new COrderInfo();
            orderInfo.OrderID = DateTime.Now.ToString("yyyyMMddhhmmssff");
            orderInfo.PosArr = new string[] { strUp, strDown };
            orderInfo.PosArrLength = 2;
            orderInfo.BookTemplateID = "SecondRoller_In_Out";
            orderInfo.OrderState = EOrderState.Added;
            orderInfo.OtherOrderData = "3";
            //orderInfo.CarrierType = 2;
            orderInfo.CalledTime = DateTime.Now;
            //orderInfo.Reserved1 = TaskID.ToString(); orderInfo.Reserved2 = TaskNo; orderInfo.Reserved3 = TaskType.ToString();
            if (!CPmsControllers.Instance.OrderDataController.OrderAdd(orderInfo, out string strMsg, out EFailCode failcode))
            {
                CLog.Instance.WriteLog("TaskErrorLog", "测试任务生成失败：" + strMsg);
            }
        }

        private void BtnFirstRoller_Click(object sender, EventArgs e)
        {
            string strUp = txtUp.Text;
            string strDown = txtDown.Text;
            if(string.IsNullOrEmpty(strDown)|| string.IsNullOrEmpty(strUp))
            {
                MessageBox.Show("输入项均不能为空");
                return;
            }
            strUp = strUp + "_1st";
            strDown = strDown + "_1st";
            string orderid="T1_"+DateTime.Now.ToString("yyyyMMddhhmmssff");
            COrderInfo orderInfo = new COrderInfo();
            orderInfo.OrderID = DateTime.Now.ToString("yyyyMMddhhmmssff");
            orderInfo.PosArr = new string[] { strUp, strDown};
            orderInfo.PosArrLength = 2;
            orderInfo.BookTemplateID = "FirstRoller_In_Out";
            orderInfo.OrderState = EOrderState.Added;
            orderInfo.OtherOrderData = "3";
            //orderInfo.CarrierType = 2;
            orderInfo.CalledTime = DateTime.Now;
            //orderInfo.Reserved1 = TaskID.ToString(); orderInfo.Reserved2 = TaskNo; orderInfo.Reserved3 = TaskType.ToString();
            if (!CPmsControllers.Instance.OrderDataController.OrderAdd(orderInfo, out string strMsg, out EFailCode failcode))
            {
                CLog.Instance.WriteLog("TaskErrorLog", "测试任务生成失败：" + strMsg);
            }
        }

        private void BtnAbutmentEnable_Click(object sender, EventArgs e)
        {
            CSystemEvent.AbutmentEnable =!CSystemEvent.AbutmentEnable;
        }

        void ScanAbutmentSwitch()
        {
            while(true)
            {
                try
                {
                    btnAbutmentEnable.Invoke(new Action(() => {
                        if (!CSystemEvent.AbutmentEnable)
                        {
                            btnAbutmentEnable.Text = "打开对接";
                            btnAbutmentEnable.BackColor = Color.Gray;
                        }
                        else
                        {
                            btnAbutmentEnable.Text = "屏蔽对接";
                            btnAbutmentEnable.BackColor = Color.Green;
                        }
                    }
                    ));
                    
                }
                catch(Exception ex)
                {

                }
                Thread.Sleep(50);
            }
        }
    }
}
