﻿using Microsoft.Practices.Prism.Commands;
using PropertyChanged;
using System.Collections.ObjectModel;
using System.Data;
using TrayBarcodeManagement.Model;
using MaxCommunication.DataBase.SQLServer;

namespace TrayBarcodeManagement.ViewModel
{
    [AddINotifyPropertyChangedInterfaceAttribute]
    public class TrayBarcodeViewModel
    {
        public ObservableCollection<TrayBarcodeModel> TrayBarcodeCollection { get; set; } = new ObservableCollection<TrayBarcodeModel>();

        public TrayBarcodeModel TrayBarcodeModel { get; set; }

        public string TrayBarcodeString { get; set; }

        public DelegateCommand ReflushCommand { get; set; }

        public DelegateCommand SearchCommand { get; set; }

        public DelegateCommand DeleteCommand { get; set; }

        public SQLServerExtension sqlServerExtension { get; set; } = new SQLServerExtension("server=.;uid=sa;pwd=123;database=PMS_KLDZ_6324");

        public TrayBarcodeViewModel()
        {
            ReflushCommand = new DelegateCommand(InitTrayBarcode);
            SearchCommand = new DelegateCommand(SearchTrayBarcode);
            DeleteCommand = new DelegateCommand(DeleteTrayBarcode);
        }

        public void InitTrayBarcode()
        {
            TrayBarcodeCollection.Clear();
            DataTable dataTable = sqlServerExtension.QueryTable("PMS_Max_TrayBarcode");
            if (dataTable == null || dataTable.Rows.Count == 0) { return; }
            foreach (DataRow item in dataTable.Rows)
            {
                TrayBarcodeCollection.Add(new TrayBarcodeModel(item));
            }
            sqlServerExtension.Disconnect();
        }

        public void SearchTrayBarcode()
        {
            DataTable dataTable = sqlServerExtension.QueryTable("PMS_Max_TrayBarcode", $"where TrayBarcode = '{TrayBarcodeString}'");
            if (dataTable == null || dataTable.Rows.Count == 0) { return; }
            TrayBarcodeCollection.Clear(); TrayBarcodeCollection.Add(new TrayBarcodeModel(dataTable.Rows[0]));
            sqlServerExtension.Disconnect();
        }

        public void DeleteTrayBarcode()
        {
            string TrayBarcodeArr = "";
            foreach (var item in TrayBarcodeCollection)
            {
                if (item.IsSelected)
                {
                    if (TrayBarcodeArr.Length == 0)
                    {
                        TrayBarcodeArr = $"'{item.TrayBarcode}'";
                    }
                    else
                    {
                        TrayBarcodeArr = TrayBarcodeArr + $",'{item.TrayBarcode}'";
                    }
                    
                }
            }
            sqlServerExtension.DeleteRecord("PMS_Max_TrayBarcode", $"where TrayBarcode in ({TrayBarcodeArr})");
            sqlServerExtension.Disconnect(); InitTrayBarcode();
        }
    }
}
